/* delayed-setting-view.c generated by valac 0.42.3, the Vala compiler
 * generated from delayed-setting-view.vala, do not modify */

/*
  This file is part of Dconf Editor

  Dconf Editor is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Dconf Editor is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Dconf Editor.  If not, see <https://www.gnu.org/licenses/>.
*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define TYPE_DELAYED_SETTING_VIEW (delayed_setting_view_get_type ())
#define DELAYED_SETTING_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DELAYED_SETTING_VIEW, DelayedSettingView))
#define DELAYED_SETTING_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DELAYED_SETTING_VIEW, DelayedSettingViewClass))
#define IS_DELAYED_SETTING_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DELAYED_SETTING_VIEW))
#define IS_DELAYED_SETTING_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DELAYED_SETTING_VIEW))
#define DELAYED_SETTING_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DELAYED_SETTING_VIEW, DelayedSettingViewClass))

typedef struct _DelayedSettingView DelayedSettingView;
typedef struct _DelayedSettingViewClass DelayedSettingViewClass;
typedef struct _DelayedSettingViewPrivate DelayedSettingViewPrivate;
enum  {
	DELAYED_SETTING_VIEW_0_PROPERTY,
	DELAYED_SETTING_VIEW_FULL_NAME_PROPERTY,
	DELAYED_SETTING_VIEW_CONTEXT_ID_PROPERTY,
	DELAYED_SETTING_VIEW_NUM_PROPERTIES
};
static GParamSpec* delayed_setting_view_properties[DELAYED_SETTING_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _DelayedSettingView {
	GtkGrid parent_instance;
	DelayedSettingViewPrivate * priv;
};

struct _DelayedSettingViewClass {
	GtkGridClass parent_class;
};

struct _DelayedSettingViewPrivate {
	GtkLabel* key_name_label;
	GtkLabel* key_value_label;
	GtkLabel* key_value_default;
	GtkLabel* planned_value_label;
	GtkLabel* planned_value_default;
	GtkButton* cancel_change_button;
	gchar* _full_name;
	guint16 _context_id;
};


static gint DelayedSettingView_private_offset;
static gpointer delayed_setting_view_parent_class = NULL;

GType delayed_setting_view_get_type (void) G_GNUC_CONST;
DelayedSettingView* delayed_setting_view_new (const gchar* name,
                                              const gchar* _full_name,
                                              guint16 _context_id,
                                              gboolean has_schema_and_is_default,
                                              GVariant* key_value,
                                              const gchar* cool_planned_value,
                                              const gchar* cool_default_value);
DelayedSettingView* delayed_setting_view_construct (GType object_type,
                                                    const gchar* name,
                                                    const gchar* _full_name,
                                                    guint16 _context_id,
                                                    gboolean has_schema_and_is_default,
                                                    GVariant* key_value,
                                                    const gchar* cool_planned_value,
                                                    const gchar* cool_default_value);
const gchar* delayed_setting_view_get_full_name (DelayedSettingView* self);
void delayed_setting_view_update_dconf_key_current_value (DelayedSettingView* self,
                                                          GVariant* key_value_or_null);
static void delayed_setting_view_update_dconf_key_planned_value (DelayedSettingView* self,
                                                          const gchar* cool_planned_value);
void delayed_setting_view_update_gsettings_key_current_value (DelayedSettingView* self,
                                                              GVariant* key_value,
                                                              gboolean is_default);
static void delayed_setting_view_update_gsettings_key_planned_value (DelayedSettingView* self,
                                                              const gchar* cool_planned_value,
                                                              const gchar* cool_default_value);
gchar* key_cool_text_value_from_variant (GVariant* variant);
static void delayed_setting_view_set_full_name (DelayedSettingView* self,
                                         const gchar* value);
guint16 delayed_setting_view_get_context_id (DelayedSettingView* self);
static void delayed_setting_view_set_context_id (DelayedSettingView* self,
                                          guint16 value);
static void delayed_setting_view_finalize (GObject * obj);
static void _vala_delayed_setting_view_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_delayed_setting_view_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);


static inline gpointer
delayed_setting_view_get_instance_private (DelayedSettingView* self)
{
	return G_STRUCT_MEMBER_P (self, DelayedSettingView_private_offset);
}


DelayedSettingView*
delayed_setting_view_construct (GType object_type,
                                const gchar* name,
                                const gchar* _full_name,
                                guint16 _context_id,
                                gboolean has_schema_and_is_default,
                                GVariant* key_value,
                                const gchar* cool_planned_value,
                                const gchar* cool_default_value)
{
	DelayedSettingView * self = NULL;
	GVariant* variant = NULL;
	const gchar* _tmp0_;
	GVariant* _tmp1_;
	GtkLabel* _tmp2_;
	GtkButton* _tmp3_;
	GVariant* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
#line 33 "../editor/delayed-setting-view.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 33 "../editor/delayed-setting-view.vala"
	g_return_val_if_fail (_full_name != NULL, NULL);
#line 33 "../editor/delayed-setting-view.vala"
	g_return_val_if_fail (key_value != NULL, NULL);
#line 35 "../editor/delayed-setting-view.vala"
	self = (DelayedSettingView*) g_object_new (object_type, "full-name", _full_name, "context-id", _context_id, NULL);
#line 36 "../editor/delayed-setting-view.vala"
	_tmp0_ = self->priv->_full_name;
#line 36 "../editor/delayed-setting-view.vala"
	_tmp1_ = g_variant_new_string (_tmp0_);
#line 36 "../editor/delayed-setting-view.vala"
	g_variant_ref_sink (_tmp1_);
#line 36 "../editor/delayed-setting-view.vala"
	variant = _tmp1_;
#line 37 "../editor/delayed-setting-view.vala"
	_tmp2_ = self->priv->key_name_label;
#line 37 "../editor/delayed-setting-view.vala"
	gtk_label_set_label (_tmp2_, name);
#line 38 "../editor/delayed-setting-view.vala"
	_tmp3_ = self->priv->cancel_change_button;
#line 38 "../editor/delayed-setting-view.vala"
	_tmp4_ = variant;
#line 38 "../editor/delayed-setting-view.vala"
	_tmp5_ = g_variant_print (_tmp4_, FALSE);
#line 38 "../editor/delayed-setting-view.vala"
	_tmp6_ = _tmp5_;
#line 38 "../editor/delayed-setting-view.vala"
	_tmp7_ = g_strconcat ("ui.dismiss-change(", _tmp6_, NULL);
#line 38 "../editor/delayed-setting-view.vala"
	_tmp8_ = _tmp7_;
#line 38 "../editor/delayed-setting-view.vala"
	_tmp9_ = g_strconcat (_tmp8_, ")", NULL);
#line 38 "../editor/delayed-setting-view.vala"
	_tmp10_ = _tmp9_;
#line 38 "../editor/delayed-setting-view.vala"
	gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp3_, _tmp10_);
#line 38 "../editor/delayed-setting-view.vala"
	_g_free0 (_tmp10_);
#line 38 "../editor/delayed-setting-view.vala"
	_g_free0 (_tmp8_);
#line 38 "../editor/delayed-setting-view.vala"
	_g_free0 (_tmp6_);
#line 40 "../editor/delayed-setting-view.vala"
	if (cool_default_value == NULL) {
#line 43 "../editor/delayed-setting-view.vala"
		delayed_setting_view_update_dconf_key_current_value (self, key_value);
#line 44 "../editor/delayed-setting-view.vala"
		delayed_setting_view_update_dconf_key_planned_value (self, cool_planned_value);
#line 200 "delayed-setting-view.c"
	} else {
#line 48 "../editor/delayed-setting-view.vala"
		delayed_setting_view_update_gsettings_key_current_value (self, key_value, has_schema_and_is_default);
#line 49 "../editor/delayed-setting-view.vala"
		delayed_setting_view_update_gsettings_key_planned_value (self, cool_planned_value, (const gchar*) cool_default_value);
#line 206 "delayed-setting-view.c"
	}
#line 33 "../editor/delayed-setting-view.vala"
	_g_variant_unref0 (variant);
#line 33 "../editor/delayed-setting-view.vala"
	return self;
#line 212 "delayed-setting-view.c"
}


DelayedSettingView*
delayed_setting_view_new (const gchar* name,
                          const gchar* _full_name,
                          guint16 _context_id,
                          gboolean has_schema_and_is_default,
                          GVariant* key_value,
                          const gchar* cool_planned_value,
                          const gchar* cool_default_value)
{
#line 33 "../editor/delayed-setting-view.vala"
	return delayed_setting_view_construct (TYPE_DELAYED_SETTING_VIEW, name, _full_name, _context_id, has_schema_and_is_default, key_value, cool_planned_value, cool_default_value);
#line 227 "delayed-setting-view.c"
}


static void
delayed_setting_view_update_gsettings_key_planned_value (DelayedSettingView* self,
                                                         const gchar* cool_planned_value,
                                                         const gchar* cool_default_value)
{
#line 57 "../editor/delayed-setting-view.vala"
	g_return_if_fail (self != NULL);
#line 57 "../editor/delayed-setting-view.vala"
	g_return_if_fail (cool_default_value != NULL);
#line 59 "../editor/delayed-setting-view.vala"
	if (cool_planned_value == NULL) {
#line 242 "delayed-setting-view.c"
		GtkLabel* _tmp0_;
		GtkLabel* _tmp1_;
		GtkLabel* _tmp2_;
#line 61 "../editor/delayed-setting-view.vala"
		_tmp0_ = self->priv->planned_value_label;
#line 61 "../editor/delayed-setting-view.vala"
		gtk_label_set_label (_tmp0_, cool_default_value);
#line 62 "../editor/delayed-setting-view.vala"
		_tmp1_ = self->priv->planned_value_default;
#line 62 "../editor/delayed-setting-view.vala"
		gtk_label_set_label (_tmp1_, _ ("Default value"));
#line 63 "../editor/delayed-setting-view.vala"
		_tmp2_ = self->priv->planned_value_default;
#line 63 "../editor/delayed-setting-view.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, TRUE);
#line 258 "delayed-setting-view.c"
	} else {
		GtkLabel* _tmp3_;
		GtkLabel* _tmp4_;
#line 67 "../editor/delayed-setting-view.vala"
		_tmp3_ = self->priv->planned_value_label;
#line 67 "../editor/delayed-setting-view.vala"
		gtk_label_set_label (_tmp3_, (const gchar*) cool_planned_value);
#line 68 "../editor/delayed-setting-view.vala"
		_tmp4_ = self->priv->planned_value_default;
#line 68 "../editor/delayed-setting-view.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp4_, FALSE);
#line 270 "delayed-setting-view.c"
	}
}


static void
delayed_setting_view_update_dconf_key_planned_value (DelayedSettingView* self,
                                                     const gchar* cool_planned_value)
{
#line 72 "../editor/delayed-setting-view.vala"
	g_return_if_fail (self != NULL);
#line 74 "../editor/delayed-setting-view.vala"
	if (cool_planned_value == NULL) {
#line 283 "delayed-setting-view.c"
		GtkLabel* _tmp0_;
		GtkLabel* _tmp1_;
		GtkLabel* _tmp2_;
#line 76 "../editor/delayed-setting-view.vala"
		_tmp0_ = self->priv->planned_value_label;
#line 76 "../editor/delayed-setting-view.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp0_, FALSE);
#line 77 "../editor/delayed-setting-view.vala"
		_tmp1_ = self->priv->planned_value_default;
#line 77 "../editor/delayed-setting-view.vala"
		gtk_label_set_label (_tmp1_, _ ("Key erased."));
#line 78 "../editor/delayed-setting-view.vala"
		_tmp2_ = self->priv->planned_value_default;
#line 78 "../editor/delayed-setting-view.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, TRUE);
#line 299 "delayed-setting-view.c"
	} else {
		GtkLabel* _tmp3_;
		GtkLabel* _tmp4_;
		GtkLabel* _tmp5_;
#line 82 "../editor/delayed-setting-view.vala"
		_tmp3_ = self->priv->planned_value_label;
#line 82 "../editor/delayed-setting-view.vala"
		gtk_label_set_label (_tmp3_, (const gchar*) cool_planned_value);
#line 83 "../editor/delayed-setting-view.vala"
		_tmp4_ = self->priv->planned_value_label;
#line 83 "../editor/delayed-setting-view.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp4_, TRUE);
#line 84 "../editor/delayed-setting-view.vala"
		_tmp5_ = self->priv->planned_value_default;
#line 84 "../editor/delayed-setting-view.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp5_, FALSE);
#line 316 "delayed-setting-view.c"
	}
}


void
delayed_setting_view_update_gsettings_key_current_value (DelayedSettingView* self,
                                                         GVariant* key_value,
                                                         gboolean is_default)
{
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 92 "../editor/delayed-setting-view.vala"
	g_return_if_fail (self != NULL);
#line 92 "../editor/delayed-setting-view.vala"
	g_return_if_fail (key_value != NULL);
#line 94 "../editor/delayed-setting-view.vala"
	_tmp0_ = self->priv->key_value_label;
#line 94 "../editor/delayed-setting-view.vala"
	_tmp1_ = key_cool_text_value_from_variant (key_value);
#line 94 "../editor/delayed-setting-view.vala"
	_tmp2_ = _tmp1_;
#line 94 "../editor/delayed-setting-view.vala"
	gtk_label_set_label (_tmp0_, _tmp2_);
#line 94 "../editor/delayed-setting-view.vala"
	_g_free0 (_tmp2_);
#line 95 "../editor/delayed-setting-view.vala"
	if (is_default) {
#line 345 "delayed-setting-view.c"
		GtkLabel* _tmp3_;
		GtkLabel* _tmp4_;
#line 97 "../editor/delayed-setting-view.vala"
		_tmp3_ = self->priv->key_value_default;
#line 97 "../editor/delayed-setting-view.vala"
		gtk_label_set_label (_tmp3_, _ ("Default value"));
#line 98 "../editor/delayed-setting-view.vala"
		_tmp4_ = self->priv->key_value_default;
#line 98 "../editor/delayed-setting-view.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp4_, TRUE);
#line 356 "delayed-setting-view.c"
	} else {
		GtkLabel* _tmp5_;
#line 101 "../editor/delayed-setting-view.vala"
		_tmp5_ = self->priv->key_value_default;
#line 101 "../editor/delayed-setting-view.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp5_, FALSE);
#line 363 "delayed-setting-view.c"
	}
}


void
delayed_setting_view_update_dconf_key_current_value (DelayedSettingView* self,
                                                     GVariant* key_value_or_null)
{
#line 104 "../editor/delayed-setting-view.vala"
	g_return_if_fail (self != NULL);
#line 106 "../editor/delayed-setting-view.vala"
	if (key_value_or_null == NULL) {
#line 376 "delayed-setting-view.c"
		GtkLabel* _tmp0_;
		GtkLabel* _tmp1_;
		GtkLabel* _tmp2_;
#line 108 "../editor/delayed-setting-view.vala"
		_tmp0_ = self->priv->key_value_label;
#line 108 "../editor/delayed-setting-view.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp0_, FALSE);
#line 109 "../editor/delayed-setting-view.vala"
		_tmp1_ = self->priv->key_value_default;
#line 109 "../editor/delayed-setting-view.vala"
		gtk_label_set_label (_tmp1_, _ ("Key erased"));
#line 110 "../editor/delayed-setting-view.vala"
		_tmp2_ = self->priv->key_value_default;
#line 110 "../editor/delayed-setting-view.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp2_, TRUE);
#line 392 "delayed-setting-view.c"
	} else {
		GtkLabel* _tmp3_;
		GtkLabel* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GtkLabel* _tmp7_;
#line 114 "../editor/delayed-setting-view.vala"
		_tmp3_ = self->priv->key_value_default;
#line 114 "../editor/delayed-setting-view.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp3_, FALSE);
#line 115 "../editor/delayed-setting-view.vala"
		_tmp4_ = self->priv->key_value_label;
#line 115 "../editor/delayed-setting-view.vala"
		_tmp5_ = key_cool_text_value_from_variant ((GVariant*) key_value_or_null);
#line 115 "../editor/delayed-setting-view.vala"
		_tmp6_ = _tmp5_;
#line 115 "../editor/delayed-setting-view.vala"
		gtk_label_set_label (_tmp4_, _tmp6_);
#line 115 "../editor/delayed-setting-view.vala"
		_g_free0 (_tmp6_);
#line 116 "../editor/delayed-setting-view.vala"
		_tmp7_ = self->priv->key_value_label;
#line 116 "../editor/delayed-setting-view.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp7_, TRUE);
#line 417 "delayed-setting-view.c"
	}
}


const gchar*
delayed_setting_view_get_full_name (DelayedSettingView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 30 "../editor/delayed-setting-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../editor/delayed-setting-view.vala"
	_tmp0_ = self->priv->_full_name;
#line 30 "../editor/delayed-setting-view.vala"
	result = _tmp0_;
#line 30 "../editor/delayed-setting-view.vala"
	return result;
#line 435 "delayed-setting-view.c"
}


static void
delayed_setting_view_set_full_name (DelayedSettingView* self,
                                    const gchar* value)
{
#line 30 "../editor/delayed-setting-view.vala"
	g_return_if_fail (self != NULL);
#line 30 "../editor/delayed-setting-view.vala"
	if (g_strcmp0 (value, delayed_setting_view_get_full_name (self)) != 0) {
#line 447 "delayed-setting-view.c"
		gchar* _tmp0_;
#line 30 "../editor/delayed-setting-view.vala"
		_tmp0_ = g_strdup (value);
#line 30 "../editor/delayed-setting-view.vala"
		_g_free0 (self->priv->_full_name);
#line 30 "../editor/delayed-setting-view.vala"
		self->priv->_full_name = _tmp0_;
#line 30 "../editor/delayed-setting-view.vala"
		g_object_notify_by_pspec ((GObject *) self, delayed_setting_view_properties[DELAYED_SETTING_VIEW_FULL_NAME_PROPERTY]);
#line 457 "delayed-setting-view.c"
	}
}


guint16
delayed_setting_view_get_context_id (DelayedSettingView* self)
{
	guint16 result;
	guint16 _tmp0_;
#line 31 "../editor/delayed-setting-view.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 31 "../editor/delayed-setting-view.vala"
	_tmp0_ = self->priv->_context_id;
#line 31 "../editor/delayed-setting-view.vala"
	result = _tmp0_;
#line 31 "../editor/delayed-setting-view.vala"
	return result;
#line 475 "delayed-setting-view.c"
}


static void
delayed_setting_view_set_context_id (DelayedSettingView* self,
                                     guint16 value)
{
#line 31 "../editor/delayed-setting-view.vala"
	g_return_if_fail (self != NULL);
#line 31 "../editor/delayed-setting-view.vala"
	if (delayed_setting_view_get_context_id (self) != value) {
#line 31 "../editor/delayed-setting-view.vala"
		self->priv->_context_id = value;
#line 31 "../editor/delayed-setting-view.vala"
		g_object_notify_by_pspec ((GObject *) self, delayed_setting_view_properties[DELAYED_SETTING_VIEW_CONTEXT_ID_PROPERTY]);
#line 491 "delayed-setting-view.c"
	}
}


static void
delayed_setting_view_class_init (DelayedSettingViewClass * klass)
{
#line 21 "../editor/delayed-setting-view.vala"
	delayed_setting_view_parent_class = g_type_class_peek_parent (klass);
#line 21 "../editor/delayed-setting-view.vala"
	g_type_class_adjust_private_offset (klass, &DelayedSettingView_private_offset);
#line 21 "../editor/delayed-setting-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_delayed_setting_view_get_property;
#line 21 "../editor/delayed-setting-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_delayed_setting_view_set_property;
#line 21 "../editor/delayed-setting-view.vala"
	G_OBJECT_CLASS (klass)->finalize = delayed_setting_view_finalize;
#line 21 "../editor/delayed-setting-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DELAYED_SETTING_VIEW_FULL_NAME_PROPERTY, delayed_setting_view_properties[DELAYED_SETTING_VIEW_FULL_NAME_PROPERTY] = g_param_spec_string ("full-name", "full-name", "full-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 21 "../editor/delayed-setting-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DELAYED_SETTING_VIEW_CONTEXT_ID_PROPERTY, delayed_setting_view_properties[DELAYED_SETTING_VIEW_CONTEXT_ID_PROPERTY] = g_param_spec_uint ("context-id", "context-id", "context-id", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 21 "../editor/delayed-setting-view.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/ca/desrt/dconf-editor/ui/delayed-setting-view.ui");
#line 21 "../editor/delayed-setting-view.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "key_name_label", FALSE, DelayedSettingView_private_offset + G_STRUCT_OFFSET (DelayedSettingViewPrivate, key_name_label));
#line 21 "../editor/delayed-setting-view.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "key_value_label", FALSE, DelayedSettingView_private_offset + G_STRUCT_OFFSET (DelayedSettingViewPrivate, key_value_label));
#line 21 "../editor/delayed-setting-view.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "key_value_default", FALSE, DelayedSettingView_private_offset + G_STRUCT_OFFSET (DelayedSettingViewPrivate, key_value_default));
#line 21 "../editor/delayed-setting-view.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "planned_value_label", FALSE, DelayedSettingView_private_offset + G_STRUCT_OFFSET (DelayedSettingViewPrivate, planned_value_label));
#line 21 "../editor/delayed-setting-view.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "planned_value_default", FALSE, DelayedSettingView_private_offset + G_STRUCT_OFFSET (DelayedSettingViewPrivate, planned_value_default));
#line 21 "../editor/delayed-setting-view.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "cancel_change_button", FALSE, DelayedSettingView_private_offset + G_STRUCT_OFFSET (DelayedSettingViewPrivate, cancel_change_button));
#line 527 "delayed-setting-view.c"
}


static void
delayed_setting_view_instance_init (DelayedSettingView * self)
{
#line 21 "../editor/delayed-setting-view.vala"
	self->priv = delayed_setting_view_get_instance_private (self);
#line 21 "../editor/delayed-setting-view.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 538 "delayed-setting-view.c"
}


static void
delayed_setting_view_finalize (GObject * obj)
{
	DelayedSettingView * self;
#line 21 "../editor/delayed-setting-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DELAYED_SETTING_VIEW, DelayedSettingView);
#line 23 "../editor/delayed-setting-view.vala"
	_g_object_unref0 (self->priv->key_name_label);
#line 24 "../editor/delayed-setting-view.vala"
	_g_object_unref0 (self->priv->key_value_label);
#line 25 "../editor/delayed-setting-view.vala"
	_g_object_unref0 (self->priv->key_value_default);
#line 26 "../editor/delayed-setting-view.vala"
	_g_object_unref0 (self->priv->planned_value_label);
#line 27 "../editor/delayed-setting-view.vala"
	_g_object_unref0 (self->priv->planned_value_default);
#line 28 "../editor/delayed-setting-view.vala"
	_g_object_unref0 (self->priv->cancel_change_button);
#line 30 "../editor/delayed-setting-view.vala"
	_g_free0 (self->priv->_full_name);
#line 21 "../editor/delayed-setting-view.vala"
	G_OBJECT_CLASS (delayed_setting_view_parent_class)->finalize (obj);
#line 564 "delayed-setting-view.c"
}


GType
delayed_setting_view_get_type (void)
{
	static volatile gsize delayed_setting_view_type_id__volatile = 0;
	if (g_once_init_enter (&delayed_setting_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DelayedSettingViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) delayed_setting_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DelayedSettingView), 0, (GInstanceInitFunc) delayed_setting_view_instance_init, NULL };
		GType delayed_setting_view_type_id;
		delayed_setting_view_type_id = g_type_register_static (gtk_grid_get_type (), "DelayedSettingView", &g_define_type_info, 0);
		DelayedSettingView_private_offset = g_type_add_instance_private (delayed_setting_view_type_id, sizeof (DelayedSettingViewPrivate));
		g_once_init_leave (&delayed_setting_view_type_id__volatile, delayed_setting_view_type_id);
	}
	return delayed_setting_view_type_id__volatile;
}


static void
_vala_delayed_setting_view_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	DelayedSettingView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DELAYED_SETTING_VIEW, DelayedSettingView);
#line 21 "../editor/delayed-setting-view.vala"
	switch (property_id) {
#line 21 "../editor/delayed-setting-view.vala"
		case DELAYED_SETTING_VIEW_FULL_NAME_PROPERTY:
#line 21 "../editor/delayed-setting-view.vala"
		g_value_set_string (value, delayed_setting_view_get_full_name (self));
#line 21 "../editor/delayed-setting-view.vala"
		break;
#line 21 "../editor/delayed-setting-view.vala"
		case DELAYED_SETTING_VIEW_CONTEXT_ID_PROPERTY:
#line 21 "../editor/delayed-setting-view.vala"
		g_value_set_uint (value, delayed_setting_view_get_context_id (self));
#line 21 "../editor/delayed-setting-view.vala"
		break;
#line 605 "delayed-setting-view.c"
		default:
#line 21 "../editor/delayed-setting-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../editor/delayed-setting-view.vala"
		break;
#line 611 "delayed-setting-view.c"
	}
}


static void
_vala_delayed_setting_view_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	DelayedSettingView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DELAYED_SETTING_VIEW, DelayedSettingView);
#line 21 "../editor/delayed-setting-view.vala"
	switch (property_id) {
#line 21 "../editor/delayed-setting-view.vala"
		case DELAYED_SETTING_VIEW_FULL_NAME_PROPERTY:
#line 21 "../editor/delayed-setting-view.vala"
		delayed_setting_view_set_full_name (self, g_value_get_string (value));
#line 21 "../editor/delayed-setting-view.vala"
		break;
#line 21 "../editor/delayed-setting-view.vala"
		case DELAYED_SETTING_VIEW_CONTEXT_ID_PROPERTY:
#line 21 "../editor/delayed-setting-view.vala"
		delayed_setting_view_set_context_id (self, g_value_get_uint (value));
#line 21 "../editor/delayed-setting-view.vala"
		break;
#line 638 "delayed-setting-view.c"
		default:
#line 21 "../editor/delayed-setting-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../editor/delayed-setting-view.vala"
		break;
#line 644 "delayed-setting-view.c"
	}
}



