/* pathbar.c generated by valac 0.42.3, the Vala compiler
 * generated from pathbar.vala, do not modify */

/*
  This file is part of Dconf Editor

  Dconf Editor is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Dconf Editor is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Dconf Editor.  If not, see <https://www.gnu.org/licenses/>.
*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>


#define TYPE_PATH_BAR (path_bar_get_type ())
#define PATH_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PATH_BAR, PathBar))
#define PATH_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PATH_BAR, PathBarClass))
#define IS_PATH_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PATH_BAR))
#define IS_PATH_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PATH_BAR))
#define PATH_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PATH_BAR, PathBarClass))

typedef struct _PathBar PathBar;
typedef struct _PathBarClass PathBarClass;
typedef struct _PathBarPrivate PathBarPrivate;

#define TYPE_PATH_BAR_ITEM (path_bar_item_get_type ())
#define PATH_BAR_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PATH_BAR_ITEM, PathBarItem))
#define PATH_BAR_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PATH_BAR_ITEM, PathBarItemClass))
#define IS_PATH_BAR_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PATH_BAR_ITEM))
#define IS_PATH_BAR_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PATH_BAR_ITEM))
#define PATH_BAR_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PATH_BAR_ITEM, PathBarItemClass))

typedef struct _PathBarItem PathBarItem;
typedef struct _PathBarItemClass PathBarItemClass;
enum  {
	PATH_BAR_0_PROPERTY,
	PATH_BAR_COMPLETE_PATH_PROPERTY,
	PATH_BAR_NUM_PROPERTIES
};
static GParamSpec* path_bar_properties[PATH_BAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_VIEW_TYPE (view_type_get_type ())
typedef struct _Block18Data Block18Data;
typedef struct _Block19Data Block19Data;

#define PATH_BAR_ITEM_TYPE_CURSOR_TYPE (path_bar_item_cursor_type_get_type ())
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block20Data Block20Data;
typedef struct _PathBarItemPrivate PathBarItemPrivate;
enum  {
	PATH_BAR_ITEM_0_PROPERTY,
	PATH_BAR_ITEM_ALTERNATIVE_ACTION_PROPERTY,
	PATH_BAR_ITEM_DEFAULT_ACTION_PROPERTY,
	PATH_BAR_ITEM_TEXT_STRING_PROPERTY,
	PATH_BAR_ITEM_NUM_PROPERTIES
};
static GParamSpec* path_bar_item_properties[PATH_BAR_ITEM_NUM_PROPERTIES];

struct _PathBar {
	GtkBox parent_instance;
	PathBarPrivate * priv;
};

struct _PathBarClass {
	GtkBoxClass parent_class;
};

struct _PathBarPrivate {
	PathBarItem* root_button;
	gchar* _complete_path;
};

typedef enum  {
	VIEW_TYPE_OBJECT,
	VIEW_TYPE_FOLDER,
	VIEW_TYPE_SEARCH
} ViewType;

struct _Block18Data {
	int _ref_count_;
	PathBar* self;
	gchar** split;
	gint split_length1;
	gint _split_size_;
	gboolean destroy_all;
	gboolean maintain_all;
	ViewType type;
};

struct _Block19Data {
	int _ref_count_;
	PathBar* self;
	gchar* action_target;
	gchar* non_ghost_path;
	gboolean is_search;
};

typedef enum  {
	PATH_BAR_ITEM_CURSOR_TYPE_DEFAULT,
	PATH_BAR_ITEM_CURSOR_TYPE_POINTER,
	PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT
} PathBarItemCursorType;

struct _Block20Data {
	int _ref_count_;
	PathBar* self;
	gboolean is_search;
};

struct _PathBarItem {
	GtkButton parent_instance;
	PathBarItemPrivate * priv;
};

struct _PathBarItemClass {
	GtkButtonClass parent_class;
};

struct _PathBarItemPrivate {
	gchar* _alternative_action;
	gchar* _default_action;
	gchar* _text_string;
	GtkLabel* text_label;
	PathBarItemCursorType cursor_type;
	gboolean hover;
};


static gint PathBar_private_offset;
static gpointer path_bar_parent_class = NULL;
static gint PathBarItem_private_offset;
static gpointer path_bar_item_parent_class = NULL;

GType path_bar_get_type (void) G_GNUC_CONST;
GType path_bar_item_get_type (void) G_GNUC_CONST;
GType view_type_get_type (void) G_GNUC_CONST;
void path_bar_set_path (PathBar* self,
                        ViewType type,
                        const gchar* path);
static Block18Data* block18_data_ref (Block18Data* _data18_);
static void block18_data_unref (void * _userdata_);
static void path_bar_update_cursors_for_search (PathBar* self,
                                         const gchar* current_path,
                                         gboolean is_search);
static void path_bar_activate_item (PathBar* self,
                             PathBarItem* item,
                             gboolean state);
static void path_bar_set_complete_path (PathBar* self,
                                 const gchar* value);
static void __lambda32_ (Block18Data* _data18_,
                  GtkWidget* child);
const gchar* path_bar_get_complete_path (PathBar* self);
const gchar* path_bar_item_get_text_string (PathBarItem* self);
static gchar** _vala_array_dup3 (gchar** self,
                          int length);
static void ___lambda32__gtk_callback (GtkWidget* widget,
                                gpointer self);
static void path_bar_add_path_bar_item (PathBar* self,
                                 const gchar* label,
                                 const gchar* complete_path,
                                 gboolean is_folder,
                                 gboolean block);
static void path_bar_add_slash_label (PathBar* self);
gchar* path_bar_get_selected_child (PathBar* self,
                                    const gchar* current_path);
void path_bar_update_ghosts (PathBar* self,
                             const gchar* non_ghost_path,
                             gboolean is_search);
static Block19Data* block19_data_ref (Block19Data* _data19_);
static void block19_data_unref (void * _userdata_);
static void __lambda33_ (Block19Data* _data19_,
                  GtkWidget* child);
GType path_bar_item_cursor_type_get_type (void) G_GNUC_CONST;
void path_bar_item_set_cursor_type (PathBarItem* self,
                                    PathBarItemCursorType cursor_type);
const gchar* path_bar_item_get_default_action (PathBarItem* self);
const gchar* path_bar_item_get_alternative_action (PathBarItem* self);
static void ___lambda33__gtk_callback (GtkWidget* widget,
                                gpointer self);
static Block20Data* block20_data_ref (Block20Data* _data20_);
static void block20_data_unref (void * _userdata_);
static void __lambda31_ (Block20Data* _data20_,
                  GtkWidget* child);
static void ___lambda31__gtk_callback (GtkWidget* widget,
                                gpointer self);
PathBarItem* path_bar_item_new (const gchar* label,
                                const gchar* _default_action,
                                const gchar* _alternative_action);
PathBarItem* path_bar_item_construct (GType object_type,
                                      const gchar* label,
                                      const gchar* _default_action,
                                      const gchar* _alternative_action);
#define MODEL_UTILS_undefined_context_id ((guint16) 0)
PathBar* path_bar_new (void);
PathBar* path_bar_construct (GType object_type);
static GObject * path_bar_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties);
static void path_bar_finalize (GObject * obj);
static void _vala_path_bar_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec);
static void _vala_path_bar_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec);
static void path_bar_item_set_new_cursor_type (PathBarItem* self,
                                        PathBarItemCursorType new_cursor_type);
static void path_bar_item_update_cursor (PathBarItem* self);
static void _path_bar_item_update_cursor_gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self);
static void path_bar_item_set_alternative_action (PathBarItem* self,
                                           const gchar* value);
static void path_bar_item_set_default_action (PathBarItem* self,
                                       const gchar* value);
static void path_bar_item_set_text_string (PathBarItem* self,
                                    const gchar* value);
static GObject * path_bar_item_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static gboolean _path_bar_item___lambda29_ (PathBarItem* self);
static gboolean __path_bar_item___lambda29__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                                    GdkEventCrossing* event,
                                                                    gpointer self);
static gboolean _path_bar_item___lambda30_ (PathBarItem* self);
static gboolean __path_bar_item___lambda30__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                    GdkEventCrossing* event,
                                                                    gpointer self);
static void path_bar_item_finalize (GObject * obj);
static void _vala_path_bar_item_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_path_bar_item_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static inline gpointer
path_bar_get_instance_private (PathBar* self)
{
	return G_STRUCT_MEMBER_P (self, PathBar_private_offset);
}


static Block18Data*
block18_data_ref (Block18Data* _data18_)
{
#line 36 "../editor/pathbar.vala"
	g_atomic_int_inc (&_data18_->_ref_count_);
#line 36 "../editor/pathbar.vala"
	return _data18_;
#line 282 "pathbar.c"
}


static void
block18_data_unref (void * _userdata_)
{
	Block18Data* _data18_;
	_data18_ = (Block18Data*) _userdata_;
#line 36 "../editor/pathbar.vala"
	if (g_atomic_int_dec_and_test (&_data18_->_ref_count_)) {
#line 293 "pathbar.c"
		PathBar* self;
#line 36 "../editor/pathbar.vala"
		self = _data18_->self;
#line 36 "../editor/pathbar.vala"
		_data18_->split = (_vala_array_free (_data18_->split, _data18_->split_length1, (GDestroyNotify) g_free), NULL);
#line 36 "../editor/pathbar.vala"
		_g_object_unref0 (self);
#line 36 "../editor/pathbar.vala"
		g_slice_free (Block18Data, _data18_);
#line 303 "pathbar.c"
	}
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 63 "../editor/pathbar.vala"
	return self ? g_object_ref (self) : NULL;
#line 313 "pathbar.c"
}


static gchar**
_vala_array_dup3 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
#line 75 "../editor/pathbar.vala"
	result = g_new0 (gchar*, length + 1);
#line 75 "../editor/pathbar.vala"
	for (i = 0; i < length; i++) {
#line 327 "pathbar.c"
		gchar* _tmp0_;
#line 75 "../editor/pathbar.vala"
		_tmp0_ = g_strdup (self[i]);
#line 75 "../editor/pathbar.vala"
		result[i] = _tmp0_;
#line 333 "pathbar.c"
	}
#line 75 "../editor/pathbar.vala"
	return result;
#line 337 "pathbar.c"
}


static void
__lambda32_ (Block18Data* _data18_,
             GtkWidget* child)
{
	PathBar* self;
	PathBarItem* item = NULL;
	PathBarItem* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp13_ = FALSE;
	PathBarItem* _tmp14_;
	PathBarItem* _tmp15_;
#line 53 "../editor/pathbar.vala"
	self = _data18_->self;
#line 53 "../editor/pathbar.vala"
	g_return_if_fail (child != NULL);
#line 54 "../editor/pathbar.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (child, gtk_label_get_type ())) {
#line 358 "pathbar.c"
		gboolean _tmp0_;
#line 56 "../editor/pathbar.vala"
		_tmp0_ = _data18_->destroy_all;
#line 56 "../editor/pathbar.vala"
		if (_tmp0_) {
#line 57 "../editor/pathbar.vala"
			gtk_widget_destroy (child);
#line 366 "pathbar.c"
		} else {
			const gchar* _tmp1_;
			gchar* _tmp2_;
			gchar* _tmp3_;
#line 59 "../editor/pathbar.vala"
			_tmp1_ = self->priv->_complete_path;
#line 59 "../editor/pathbar.vala"
			_tmp2_ = g_strconcat (_tmp1_, "/", NULL);
#line 59 "../editor/pathbar.vala"
			_tmp3_ = _tmp2_;
#line 59 "../editor/pathbar.vala"
			path_bar_set_complete_path (self, _tmp3_);
#line 59 "../editor/pathbar.vala"
			_g_free0 (_tmp3_);
#line 381 "pathbar.c"
		}
#line 60 "../editor/pathbar.vala"
		return;
#line 385 "pathbar.c"
	}
#line 63 "../editor/pathbar.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (child, TYPE_PATH_BAR_ITEM, PathBarItem));
#line 63 "../editor/pathbar.vala"
	item = _tmp4_;
#line 65 "../editor/pathbar.vala"
	_tmp5_ = _data18_->maintain_all;
#line 65 "../editor/pathbar.vala"
	if (_tmp5_) {
#line 395 "pathbar.c"
		const gchar* _tmp6_;
		PathBarItem* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		PathBarItem* _tmp12_;
#line 67 "../editor/pathbar.vala"
		_tmp6_ = self->priv->_complete_path;
#line 67 "../editor/pathbar.vala"
		_tmp7_ = item;
#line 67 "../editor/pathbar.vala"
		_tmp8_ = path_bar_item_get_text_string (_tmp7_);
#line 67 "../editor/pathbar.vala"
		_tmp9_ = _tmp8_;
#line 67 "../editor/pathbar.vala"
		_tmp10_ = g_strconcat (_tmp6_, _tmp9_, NULL);
#line 67 "../editor/pathbar.vala"
		_tmp11_ = _tmp10_;
#line 67 "../editor/pathbar.vala"
		path_bar_set_complete_path (self, _tmp11_);
#line 67 "../editor/pathbar.vala"
		_g_free0 (_tmp11_);
#line 68 "../editor/pathbar.vala"
		_tmp12_ = item;
#line 68 "../editor/pathbar.vala"
		path_bar_activate_item (self, _tmp12_, FALSE);
#line 69 "../editor/pathbar.vala"
		_g_object_unref0 (item);
#line 69 "../editor/pathbar.vala"
		return;
#line 427 "pathbar.c"
	}
#line 72 "../editor/pathbar.vala"
	_tmp14_ = item;
#line 72 "../editor/pathbar.vala"
	_tmp15_ = self->priv->root_button;
#line 72 "../editor/pathbar.vala"
	if (_tmp14_ == _tmp15_) {
#line 72 "../editor/pathbar.vala"
		_tmp13_ = TRUE;
#line 437 "pathbar.c"
	} else {
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_;
#line 72 "../editor/pathbar.vala"
		_tmp17_ = _data18_->destroy_all;
#line 72 "../editor/pathbar.vala"
		if (!_tmp17_) {
#line 445 "pathbar.c"
			PathBarItem* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			gchar** _tmp21_;
			gint _tmp21__length1;
			const gchar* _tmp22_;
#line 72 "../editor/pathbar.vala"
			_tmp18_ = item;
#line 72 "../editor/pathbar.vala"
			_tmp19_ = path_bar_item_get_text_string (_tmp18_);
#line 72 "../editor/pathbar.vala"
			_tmp20_ = _tmp19_;
#line 72 "../editor/pathbar.vala"
			_tmp21_ = _data18_->split;
#line 72 "../editor/pathbar.vala"
			_tmp21__length1 = _data18_->split_length1;
#line 72 "../editor/pathbar.vala"
			_tmp22_ = _tmp21_[0];
#line 72 "../editor/pathbar.vala"
			_tmp16_ = g_strcmp0 (_tmp20_, _tmp22_) == 0;
#line 466 "pathbar.c"
		} else {
#line 72 "../editor/pathbar.vala"
			_tmp16_ = FALSE;
#line 470 "pathbar.c"
		}
#line 72 "../editor/pathbar.vala"
		_tmp13_ = _tmp16_;
#line 474 "pathbar.c"
	}
#line 72 "../editor/pathbar.vala"
	if (_tmp13_) {
#line 478 "pathbar.c"
		const gchar* _tmp23_;
		gchar** _tmp24_;
		gint _tmp24__length1;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar** _tmp28_;
		gint _tmp28__length1;
		gchar** _tmp29_;
		gint _tmp29__length1;
		gchar** _tmp30_;
		gint _tmp30__length1;
		gboolean _tmp31_ = FALSE;
		gchar** _tmp32_;
		gint _tmp32__length1;
#line 74 "../editor/pathbar.vala"
		_tmp23_ = self->priv->_complete_path;
#line 74 "../editor/pathbar.vala"
		_tmp24_ = _data18_->split;
#line 74 "../editor/pathbar.vala"
		_tmp24__length1 = _data18_->split_length1;
#line 74 "../editor/pathbar.vala"
		_tmp25_ = _tmp24_[0];
#line 74 "../editor/pathbar.vala"
		_tmp26_ = g_strconcat (_tmp23_, _tmp25_, NULL);
#line 74 "../editor/pathbar.vala"
		_tmp27_ = _tmp26_;
#line 74 "../editor/pathbar.vala"
		path_bar_set_complete_path (self, _tmp27_);
#line 74 "../editor/pathbar.vala"
		_g_free0 (_tmp27_);
#line 75 "../editor/pathbar.vala"
		_tmp28_ = _data18_->split;
#line 75 "../editor/pathbar.vala"
		_tmp28__length1 = _data18_->split_length1;
#line 75 "../editor/pathbar.vala"
		_tmp29_ = _data18_->split;
#line 75 "../editor/pathbar.vala"
		_tmp29__length1 = _data18_->split_length1;
#line 75 "../editor/pathbar.vala"
		_tmp30_ = ((_tmp28_ + 1) != NULL) ? _vala_array_dup3 (_tmp28_ + 1, _tmp29__length1 - 1) : ((gpointer) (_tmp28_ + 1));
#line 75 "../editor/pathbar.vala"
		_tmp30__length1 = _tmp29__length1 - 1;
#line 75 "../editor/pathbar.vala"
		_data18_->split = (_vala_array_free (_data18_->split, _data18_->split_length1, (GDestroyNotify) g_free), NULL);
#line 75 "../editor/pathbar.vala"
		_data18_->split = _tmp30_;
#line 75 "../editor/pathbar.vala"
		_data18_->split_length1 = _tmp30__length1;
#line 75 "../editor/pathbar.vala"
		_data18_->_split_size_ = _data18_->split_length1;
#line 76 "../editor/pathbar.vala"
		_tmp32_ = _data18_->split;
#line 76 "../editor/pathbar.vala"
		_tmp32__length1 = _data18_->split_length1;
#line 76 "../editor/pathbar.vala"
		if (_tmp32__length1 == 0) {
#line 76 "../editor/pathbar.vala"
			_tmp31_ = TRUE;
#line 538 "pathbar.c"
		} else {
			gboolean _tmp33_ = FALSE;
			gchar** _tmp34_;
			gint _tmp34__length1;
#line 76 "../editor/pathbar.vala"
			_tmp34_ = _data18_->split;
#line 76 "../editor/pathbar.vala"
			_tmp34__length1 = _data18_->split_length1;
#line 76 "../editor/pathbar.vala"
			if (_tmp34__length1 == 1) {
#line 76 "../editor/pathbar.vala"
				_tmp33_ = _data18_->type == VIEW_TYPE_FOLDER;
#line 551 "pathbar.c"
			} else {
#line 76 "../editor/pathbar.vala"
				_tmp33_ = FALSE;
#line 555 "pathbar.c"
			}
#line 76 "../editor/pathbar.vala"
			_tmp31_ = _tmp33_;
#line 559 "pathbar.c"
		}
#line 76 "../editor/pathbar.vala"
		if (_tmp31_) {
#line 563 "pathbar.c"
			PathBarItem* _tmp35_;
#line 78 "../editor/pathbar.vala"
			_tmp35_ = item;
#line 78 "../editor/pathbar.vala"
			path_bar_activate_item (self, _tmp35_, TRUE);
#line 79 "../editor/pathbar.vala"
			_data18_->maintain_all = TRUE;
#line 571 "pathbar.c"
		} else {
			PathBarItem* _tmp36_;
#line 82 "../editor/pathbar.vala"
			_tmp36_ = item;
#line 82 "../editor/pathbar.vala"
			path_bar_activate_item (self, _tmp36_, FALSE);
#line 578 "pathbar.c"
		}
#line 83 "../editor/pathbar.vala"
		_g_object_unref0 (item);
#line 83 "../editor/pathbar.vala"
		return;
#line 584 "pathbar.c"
	}
#line 86 "../editor/pathbar.vala"
	gtk_widget_destroy (child);
#line 87 "../editor/pathbar.vala"
	_data18_->destroy_all = TRUE;
#line 53 "../editor/pathbar.vala"
	_g_object_unref0 (item);
#line 592 "pathbar.c"
}


static void
___lambda32__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
#line 53 "../editor/pathbar.vala"
	__lambda32_ (self, widget);
#line 602 "pathbar.c"
}


void
path_bar_set_path (PathBar* self,
                   ViewType type,
                   const gchar* path)
{
	Block18Data* _data18_;
	PathBarItem* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar* last = NULL;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** _tmp4_;
	gint _tmp4__length1;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
#line 36 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 36 "../editor/pathbar.vala"
	g_return_if_fail (path != NULL);
#line 36 "../editor/pathbar.vala"
	_data18_ = g_slice_new0 (Block18Data);
#line 36 "../editor/pathbar.vala"
	_data18_->_ref_count_ = 1;
#line 36 "../editor/pathbar.vala"
	_data18_->self = g_object_ref (self);
#line 36 "../editor/pathbar.vala"
	_data18_->type = type;
#line 38 "../editor/pathbar.vala"
	if (_data18_->type == VIEW_TYPE_SEARCH) {
#line 40 "../editor/pathbar.vala"
		path_bar_update_cursors_for_search (self, path, TRUE);
#line 41 "../editor/pathbar.vala"
		block18_data_unref (_data18_);
#line 41 "../editor/pathbar.vala"
		_data18_ = NULL;
#line 41 "../editor/pathbar.vala"
		return;
#line 646 "pathbar.c"
	}
#line 43 "../editor/pathbar.vala"
	path_bar_update_cursors_for_search (self, path, FALSE);
#line 45 "../editor/pathbar.vala"
	_tmp0_ = self->priv->root_button;
#line 45 "../editor/pathbar.vala"
	path_bar_activate_item (self, _tmp0_, g_strcmp0 (path, "/") == 0);
#line 47 "../editor/pathbar.vala"
	path_bar_set_complete_path (self, "");
#line 48 "../editor/pathbar.vala"
	_tmp2_ = _tmp1_ = g_strsplit (path, "/", 0);
#line 48 "../editor/pathbar.vala"
	_data18_->split = _tmp2_;
#line 48 "../editor/pathbar.vala"
	_data18_->split_length1 = _vala_array_length (_tmp1_);
#line 48 "../editor/pathbar.vala"
	_data18_->_split_size_ = _data18_->split_length1;
#line 49 "../editor/pathbar.vala"
	_tmp3_ = _data18_->split;
#line 49 "../editor/pathbar.vala"
	_tmp3__length1 = _data18_->split_length1;
#line 49 "../editor/pathbar.vala"
	_tmp4_ = _data18_->split;
#line 49 "../editor/pathbar.vala"
	_tmp4__length1 = _data18_->split_length1;
#line 49 "../editor/pathbar.vala"
	_tmp5_ = _tmp3_[_tmp4__length1 - 1];
#line 49 "../editor/pathbar.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 49 "../editor/pathbar.vala"
	last = _tmp6_;
#line 51 "../editor/pathbar.vala"
	_data18_->destroy_all = FALSE;
#line 52 "../editor/pathbar.vala"
	_data18_->maintain_all = FALSE;
#line 53 "../editor/pathbar.vala"
	gtk_container_foreach ((GtkContainer*) self, ___lambda32__gtk_callback, _data18_);
#line 90 "../editor/pathbar.vala"
	_tmp7_ = _data18_->split;
#line 90 "../editor/pathbar.vala"
	_tmp7__length1 = _data18_->split_length1;
#line 90 "../editor/pathbar.vala"
	if (_tmp7__length1 > 0) {
#line 690 "pathbar.c"
		gchar** _tmp8_;
		gint _tmp8__length1;
#line 93 "../editor/pathbar.vala"
		_tmp8_ = _data18_->split;
#line 93 "../editor/pathbar.vala"
		_tmp8__length1 = _data18_->split_length1;
#line 93 "../editor/pathbar.vala"
		if (_tmp8__length1 > 1) {
#line 699 "pathbar.c"
			guint index = 0U;
			gchar** _tmp9_;
			gint _tmp9__length1;
			gchar** _tmp10_;
			gint _tmp10__length1;
#line 95 "../editor/pathbar.vala"
			index = (guint) 0;
#line 96 "../editor/pathbar.vala"
			_tmp9_ = _data18_->split;
#line 96 "../editor/pathbar.vala"
			_tmp9__length1 = _data18_->split_length1;
#line 96 "../editor/pathbar.vala"
			_tmp10_ = _data18_->split;
#line 96 "../editor/pathbar.vala"
			_tmp10__length1 = _data18_->split_length1;
#line 715 "pathbar.c"
			{
				gchar** item_collection = NULL;
				gint item_collection_length1 = 0;
				gint _item_collection_size_ = 0;
				gint item_it = 0;
#line 96 "../editor/pathbar.vala"
				item_collection = _tmp9_ + 0;
#line 96 "../editor/pathbar.vala"
				item_collection_length1 = (_tmp10__length1 - 1) - 0;
#line 96 "../editor/pathbar.vala"
				for (item_it = 0; item_it < ((_tmp10__length1 - 1) - 0); item_it = item_it + 1) {
#line 727 "pathbar.c"
					gchar* _tmp11_;
					gchar* item = NULL;
#line 96 "../editor/pathbar.vala"
					_tmp11_ = g_strdup (item_collection[item_it]);
#line 96 "../editor/pathbar.vala"
					item = _tmp11_;
#line 734 "pathbar.c"
					{
						const gchar* _tmp12_;
						const gchar* _tmp13_;
						gchar* _tmp14_;
						gchar* _tmp15_;
						gchar* _tmp16_;
						gchar* _tmp17_;
						gboolean _tmp18_ = FALSE;
						const gchar* _tmp21_;
						const gchar* _tmp22_;
						guint _tmp23_;
#line 98 "../editor/pathbar.vala"
						_tmp12_ = self->priv->_complete_path;
#line 98 "../editor/pathbar.vala"
						_tmp13_ = item;
#line 98 "../editor/pathbar.vala"
						_tmp14_ = g_strconcat (_tmp13_, "/", NULL);
#line 98 "../editor/pathbar.vala"
						_tmp15_ = _tmp14_;
#line 98 "../editor/pathbar.vala"
						_tmp16_ = g_strconcat (_tmp12_, _tmp15_, NULL);
#line 98 "../editor/pathbar.vala"
						_tmp17_ = _tmp16_;
#line 98 "../editor/pathbar.vala"
						path_bar_set_complete_path (self, _tmp17_);
#line 98 "../editor/pathbar.vala"
						_g_free0 (_tmp17_);
#line 98 "../editor/pathbar.vala"
						_g_free0 (_tmp15_);
#line 99 "../editor/pathbar.vala"
						if (_data18_->type == VIEW_TYPE_FOLDER) {
#line 766 "pathbar.c"
							guint _tmp19_;
							gchar** _tmp20_;
							gint _tmp20__length1;
#line 99 "../editor/pathbar.vala"
							_tmp19_ = index;
#line 99 "../editor/pathbar.vala"
							_tmp20_ = _data18_->split;
#line 99 "../editor/pathbar.vala"
							_tmp20__length1 = _data18_->split_length1;
#line 99 "../editor/pathbar.vala"
							_tmp18_ = _tmp19_ == ((guint) (_tmp20__length1 - 2));
#line 778 "pathbar.c"
						} else {
#line 99 "../editor/pathbar.vala"
							_tmp18_ = FALSE;
#line 782 "pathbar.c"
						}
#line 99 "../editor/pathbar.vala"
						_tmp21_ = item;
#line 99 "../editor/pathbar.vala"
						_tmp22_ = self->priv->_complete_path;
#line 99 "../editor/pathbar.vala"
						path_bar_add_path_bar_item (self, _tmp21_, _tmp22_, TRUE, _tmp18_);
#line 100 "../editor/pathbar.vala"
						path_bar_add_slash_label (self);
#line 101 "../editor/pathbar.vala"
						_tmp23_ = index;
#line 101 "../editor/pathbar.vala"
						index = _tmp23_ + 1;
#line 96 "../editor/pathbar.vala"
						_g_free0 (item);
#line 798 "pathbar.c"
					}
				}
			}
		}
#line 106 "../editor/pathbar.vala"
		if (_data18_->type == VIEW_TYPE_OBJECT) {
#line 805 "pathbar.c"
			const gchar* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			const gchar* _tmp28_;
			const gchar* _tmp29_;
#line 108 "../editor/pathbar.vala"
			_tmp24_ = self->priv->_complete_path;
#line 108 "../editor/pathbar.vala"
			_tmp25_ = last;
#line 108 "../editor/pathbar.vala"
			_tmp26_ = g_strconcat (_tmp24_, _tmp25_, NULL);
#line 108 "../editor/pathbar.vala"
			_tmp27_ = _tmp26_;
#line 108 "../editor/pathbar.vala"
			path_bar_set_complete_path (self, _tmp27_);
#line 108 "../editor/pathbar.vala"
			_g_free0 (_tmp27_);
#line 109 "../editor/pathbar.vala"
			_tmp28_ = last;
#line 109 "../editor/pathbar.vala"
			_tmp29_ = self->priv->_complete_path;
#line 109 "../editor/pathbar.vala"
			path_bar_add_path_bar_item (self, _tmp28_, _tmp29_, FALSE, TRUE);
#line 830 "pathbar.c"
		}
	}
#line 113 "../editor/pathbar.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 36 "../editor/pathbar.vala"
	_g_free0 (last);
#line 36 "../editor/pathbar.vala"
	block18_data_unref (_data18_);
#line 36 "../editor/pathbar.vala"
	_data18_ = NULL;
#line 841 "pathbar.c"
}


static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1082 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1082 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1084 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1084 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 866 "pathbar.c"
		gchar* _tmp2_;
#line 1085 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1085 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1085 "glib-2.0.vapi"
		return result;
#line 874 "pathbar.c"
	} else {
#line 1087 "glib-2.0.vapi"
		result = -1;
#line 1087 "glib-2.0.vapi"
		return result;
#line 880 "pathbar.c"
	}
}


static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gchar* _tmp8_;
#line 1425 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1426 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1426 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1426 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1427 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 907 "pathbar.c"
		glong _tmp2_;
#line 1428 "glib-2.0.vapi"
		_tmp2_ = string_length;
#line 1428 "glib-2.0.vapi"
		start = _tmp2_ + start;
#line 913 "pathbar.c"
	}
#line 1430 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 917 "pathbar.c"
		glong _tmp3_;
#line 1431 "glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1431 "glib-2.0.vapi"
		end = _tmp3_ + end;
#line 923 "pathbar.c"
	}
#line 1433 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 927 "pathbar.c"
		glong _tmp5_;
#line 1433 "glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1433 "glib-2.0.vapi"
		_tmp4_ = start <= _tmp5_;
#line 933 "pathbar.c"
	} else {
#line 1433 "glib-2.0.vapi"
		_tmp4_ = FALSE;
#line 937 "pathbar.c"
	}
#line 1433 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp4_, NULL);
#line 1434 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 943 "pathbar.c"
		glong _tmp7_;
#line 1434 "glib-2.0.vapi"
		_tmp7_ = string_length;
#line 1434 "glib-2.0.vapi"
		_tmp6_ = end <= _tmp7_;
#line 949 "pathbar.c"
	} else {
#line 1434 "glib-2.0.vapi"
		_tmp6_ = FALSE;
#line 953 "pathbar.c"
	}
#line 1434 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp6_, NULL);
#line 1435 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1436 "glib-2.0.vapi"
	_tmp8_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1436 "glib-2.0.vapi"
	result = _tmp8_;
#line 1436 "glib-2.0.vapi"
	return result;
#line 965 "pathbar.c"
}


gchar*
path_bar_get_selected_child (PathBar* self,
                             const gchar* current_path)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gint index_of_last_slash = 0;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gchar* _tmp7_ = NULL;
	gint _tmp8_;
#line 116 "../editor/pathbar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 116 "../editor/pathbar.vala"
	g_return_val_if_fail (current_path != NULL, NULL);
#line 118 "../editor/pathbar.vala"
	_tmp1_ = self->priv->_complete_path;
#line 118 "../editor/pathbar.vala"
	if (!g_str_has_prefix (_tmp1_, current_path)) {
#line 118 "../editor/pathbar.vala"
		_tmp0_ = TRUE;
#line 992 "pathbar.c"
	} else {
		const gchar* _tmp2_;
#line 118 "../editor/pathbar.vala"
		_tmp2_ = self->priv->_complete_path;
#line 118 "../editor/pathbar.vala"
		_tmp0_ = g_strcmp0 (_tmp2_, current_path) == 0;
#line 999 "pathbar.c"
	}
#line 118 "../editor/pathbar.vala"
	if (_tmp0_) {
#line 1003 "pathbar.c"
		gchar* _tmp3_;
#line 119 "../editor/pathbar.vala"
		_tmp3_ = g_strdup ("");
#line 119 "../editor/pathbar.vala"
		result = _tmp3_;
#line 119 "../editor/pathbar.vala"
		return result;
#line 1011 "pathbar.c"
	}
#line 120 "../editor/pathbar.vala"
	_tmp4_ = self->priv->_complete_path;
#line 120 "../editor/pathbar.vala"
	_tmp5_ = strlen (current_path);
#line 120 "../editor/pathbar.vala"
	_tmp6_ = _tmp5_;
#line 120 "../editor/pathbar.vala"
	index_of_last_slash = string_index_of (_tmp4_, "/", _tmp6_);
#line 121 "../editor/pathbar.vala"
	_tmp8_ = index_of_last_slash;
#line 121 "../editor/pathbar.vala"
	if (_tmp8_ == -1) {
#line 1025 "pathbar.c"
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 121 "../editor/pathbar.vala"
		_tmp9_ = self->priv->_complete_path;
#line 121 "../editor/pathbar.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 121 "../editor/pathbar.vala"
		_g_free0 (_tmp7_);
#line 121 "../editor/pathbar.vala"
		_tmp7_ = _tmp10_;
#line 1036 "pathbar.c"
	} else {
		const gchar* _tmp11_;
		gint _tmp12_;
		gchar* _tmp13_;
#line 121 "../editor/pathbar.vala"
		_tmp11_ = self->priv->_complete_path;
#line 121 "../editor/pathbar.vala"
		_tmp12_ = index_of_last_slash;
#line 121 "../editor/pathbar.vala"
		_tmp13_ = string_slice (_tmp11_, (glong) 0, (glong) (_tmp12_ + 1));
#line 121 "../editor/pathbar.vala"
		_g_free0 (_tmp7_);
#line 121 "../editor/pathbar.vala"
		_tmp7_ = _tmp13_;
#line 1051 "pathbar.c"
	}
#line 121 "../editor/pathbar.vala"
	result = _tmp7_;
#line 121 "../editor/pathbar.vala"
	return result;
#line 1057 "pathbar.c"
}


static Block19Data*
block19_data_ref (Block19Data* _data19_)
{
#line 124 "../editor/pathbar.vala"
	g_atomic_int_inc (&_data19_->_ref_count_);
#line 124 "../editor/pathbar.vala"
	return _data19_;
#line 1068 "pathbar.c"
}


static void
block19_data_unref (void * _userdata_)
{
	Block19Data* _data19_;
	_data19_ = (Block19Data*) _userdata_;
#line 124 "../editor/pathbar.vala"
	if (g_atomic_int_dec_and_test (&_data19_->_ref_count_)) {
#line 1079 "pathbar.c"
		PathBar* self;
#line 124 "../editor/pathbar.vala"
		self = _data19_->self;
#line 124 "../editor/pathbar.vala"
		_g_free0 (_data19_->action_target);
#line 124 "../editor/pathbar.vala"
		_g_free0 (_data19_->non_ghost_path);
#line 124 "../editor/pathbar.vala"
		_g_object_unref0 (self);
#line 124 "../editor/pathbar.vala"
		g_slice_free (Block19Data, _data19_);
#line 1091 "pathbar.c"
	}
}


static gpointer
_g_variant_ref0 (gpointer self)
{
#line 132 "../editor/pathbar.vala"
	return self ? g_variant_ref (self) : NULL;
#line 1101 "pathbar.c"
}


static void
__lambda33_ (Block19Data* _data19_,
             GtkWidget* child)
{
	PathBar* self;
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
#line 127 "../editor/pathbar.vala"
	self = _data19_->self;
#line 127 "../editor/pathbar.vala"
	g_return_if_fail (child != NULL);
#line 128 "../editor/pathbar.vala"
	_tmp0_ = gtk_widget_get_style_context (child);
#line 128 "../editor/pathbar.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 128 "../editor/pathbar.vala"
	context = _tmp1_;
#line 129 "../editor/pathbar.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (child, TYPE_PATH_BAR_ITEM)) {
#line 1125 "pathbar.c"
		PathBarItem* item = NULL;
		PathBarItem* _tmp2_;
		GVariant* variant = NULL;
		PathBarItem* _tmp3_;
		GVariant* _tmp4_;
		GVariant* _tmp5_;
		GVariant* _tmp6_;
		GVariant* _tmp7_;
		const gchar* _tmp8_;
		GtkStyleContext* _tmp13_;
#line 131 "../editor/pathbar.vala"
		_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (child, TYPE_PATH_BAR_ITEM, PathBarItem));
#line 131 "../editor/pathbar.vala"
		item = _tmp2_;
#line 132 "../editor/pathbar.vala"
		_tmp3_ = item;
#line 132 "../editor/pathbar.vala"
		_tmp4_ = gtk_actionable_get_action_target_value ((GtkActionable*) _tmp3_);
#line 132 "../editor/pathbar.vala"
		_tmp5_ = _g_variant_ref0 (_tmp4_);
#line 132 "../editor/pathbar.vala"
		variant = _tmp5_;
#line 133 "../editor/pathbar.vala"
		_tmp6_ = variant;
#line 133 "../editor/pathbar.vala"
		if (_tmp6_ == NULL) {
#line 134 "../editor/pathbar.vala"
			g_assert_not_reached ();
#line 1154 "pathbar.c"
		}
#line 135 "../editor/pathbar.vala"
		_tmp7_ = variant;
#line 135 "../editor/pathbar.vala"
		_tmp8_ = g_variant_get_type_string ((GVariant*) _tmp7_);
#line 135 "../editor/pathbar.vala"
		if (g_strcmp0 (_tmp8_, "s") == 0) {
#line 1162 "pathbar.c"
			GVariant* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 136 "../editor/pathbar.vala"
			_tmp9_ = variant;
#line 136 "../editor/pathbar.vala"
			_tmp10_ = g_variant_get_string ((GVariant*) _tmp9_, NULL);
#line 136 "../editor/pathbar.vala"
			_tmp11_ = g_strdup (_tmp10_);
#line 136 "../editor/pathbar.vala"
			_g_free0 (_data19_->action_target);
#line 136 "../editor/pathbar.vala"
			_data19_->action_target = _tmp11_;
#line 1176 "pathbar.c"
		} else {
			guint16 unused = 0U;
			GVariant* _tmp12_;
#line 140 "../editor/pathbar.vala"
			_tmp12_ = variant;
#line 140 "../editor/pathbar.vala"
			g_variant_get ((GVariant*) _tmp12_, "(sq)", &_data19_->action_target, &unused, NULL);
#line 1184 "pathbar.c"
		}
#line 143 "../editor/pathbar.vala"
		_tmp13_ = context;
#line 143 "../editor/pathbar.vala"
		if (gtk_style_context_has_class (_tmp13_, "active")) {
#line 145 "../editor/pathbar.vala"
			if (_data19_->is_search) {
#line 1192 "pathbar.c"
				PathBarItem* _tmp14_;
				PathBarItem* _tmp15_;
				PathBarItem* _tmp16_;
				const gchar* _tmp17_;
				const gchar* _tmp18_;
#line 147 "../editor/pathbar.vala"
				_tmp14_ = item;
#line 147 "../editor/pathbar.vala"
				path_bar_item_set_cursor_type (_tmp14_, PATH_BAR_ITEM_CURSOR_TYPE_POINTER);
#line 148 "../editor/pathbar.vala"
				_tmp15_ = item;
#line 148 "../editor/pathbar.vala"
				_tmp16_ = item;
#line 148 "../editor/pathbar.vala"
				_tmp17_ = path_bar_item_get_default_action (_tmp16_);
#line 148 "../editor/pathbar.vala"
				_tmp18_ = _tmp17_;
#line 148 "../editor/pathbar.vala"
				gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp15_, _tmp18_);
#line 1212 "pathbar.c"
			} else {
				PathBarItem* _tmp19_;
				PathBarItem* _tmp20_;
#line 152 "../editor/pathbar.vala"
				_tmp19_ = item;
#line 152 "../editor/pathbar.vala"
				path_bar_item_set_cursor_type (_tmp19_, PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT);
#line 153 "../editor/pathbar.vala"
				_tmp20_ = item;
#line 153 "../editor/pathbar.vala"
				gtk_actionable_set_action_name ((GtkActionable*) _tmp20_, "ui.empty");
#line 1224 "pathbar.c"
			}
#line 155 "../editor/pathbar.vala"
			if (g_str_has_prefix (_data19_->non_ghost_path, _data19_->action_target)) {
#line 1228 "pathbar.c"
				GtkStyleContext* _tmp21_;
#line 156 "../editor/pathbar.vala"
				_tmp21_ = context;
#line 156 "../editor/pathbar.vala"
				gtk_style_context_remove_class (_tmp21_, "inexistent");
#line 1234 "pathbar.c"
			} else {
				GtkStyleContext* _tmp22_;
#line 158 "../editor/pathbar.vala"
				_tmp22_ = context;
#line 158 "../editor/pathbar.vala"
				gtk_style_context_add_class (_tmp22_, "inexistent");
#line 1241 "pathbar.c"
			}
		} else {
#line 160 "../editor/pathbar.vala"
			if (g_str_has_prefix (_data19_->non_ghost_path, _data19_->action_target)) {
#line 1246 "pathbar.c"
				PathBarItem* _tmp23_;
				PathBarItem* _tmp24_;
				PathBarItem* _tmp25_;
				const gchar* _tmp26_;
				const gchar* _tmp27_;
				GtkStyleContext* _tmp28_;
#line 162 "../editor/pathbar.vala"
				_tmp23_ = item;
#line 162 "../editor/pathbar.vala"
				path_bar_item_set_cursor_type (_tmp23_, PATH_BAR_ITEM_CURSOR_TYPE_POINTER);
#line 163 "../editor/pathbar.vala"
				_tmp24_ = item;
#line 163 "../editor/pathbar.vala"
				_tmp25_ = item;
#line 163 "../editor/pathbar.vala"
				_tmp26_ = path_bar_item_get_default_action (_tmp25_);
#line 163 "../editor/pathbar.vala"
				_tmp27_ = _tmp26_;
#line 163 "../editor/pathbar.vala"
				gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp24_, _tmp27_);
#line 164 "../editor/pathbar.vala"
				_tmp28_ = context;
#line 164 "../editor/pathbar.vala"
				gtk_style_context_remove_class (_tmp28_, "inexistent");
#line 1271 "pathbar.c"
			} else {
				PathBarItem* _tmp29_;
				PathBarItem* _tmp30_;
				PathBarItem* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				GtkStyleContext* _tmp34_;
#line 168 "../editor/pathbar.vala"
				_tmp29_ = item;
#line 168 "../editor/pathbar.vala"
				path_bar_item_set_cursor_type (_tmp29_, PATH_BAR_ITEM_CURSOR_TYPE_DEFAULT);
#line 169 "../editor/pathbar.vala"
				_tmp30_ = item;
#line 169 "../editor/pathbar.vala"
				_tmp31_ = item;
#line 169 "../editor/pathbar.vala"
				_tmp32_ = path_bar_item_get_alternative_action (_tmp31_);
#line 169 "../editor/pathbar.vala"
				_tmp33_ = _tmp32_;
#line 169 "../editor/pathbar.vala"
				gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp30_, _tmp33_);
#line 170 "../editor/pathbar.vala"
				_tmp34_ = context;
#line 170 "../editor/pathbar.vala"
				gtk_style_context_add_class (_tmp34_, "inexistent");
#line 1297 "pathbar.c"
			}
		}
#line 129 "../editor/pathbar.vala"
		_g_variant_unref0 (variant);
#line 129 "../editor/pathbar.vala"
		_g_object_unref0 (item);
#line 1304 "pathbar.c"
	} else {
#line 173 "../editor/pathbar.vala"
		if (g_str_has_prefix (_data19_->non_ghost_path, _data19_->action_target)) {
#line 1308 "pathbar.c"
			GtkStyleContext* _tmp35_;
#line 174 "../editor/pathbar.vala"
			_tmp35_ = context;
#line 174 "../editor/pathbar.vala"
			gtk_style_context_remove_class (_tmp35_, "inexistent");
#line 1314 "pathbar.c"
		} else {
			GtkStyleContext* _tmp36_;
#line 176 "../editor/pathbar.vala"
			_tmp36_ = context;
#line 176 "../editor/pathbar.vala"
			gtk_style_context_add_class (_tmp36_, "inexistent");
#line 1321 "pathbar.c"
		}
	}
#line 127 "../editor/pathbar.vala"
	_g_object_unref0 (context);
#line 1326 "pathbar.c"
}


static void
___lambda33__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
#line 127 "../editor/pathbar.vala"
	__lambda33_ (self, widget);
#line 1336 "pathbar.c"
}


void
path_bar_update_ghosts (PathBar* self,
                        const gchar* non_ghost_path,
                        gboolean is_search)
{
	Block19Data* _data19_;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 124 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 124 "../editor/pathbar.vala"
	g_return_if_fail (non_ghost_path != NULL);
#line 124 "../editor/pathbar.vala"
	_data19_ = g_slice_new0 (Block19Data);
#line 124 "../editor/pathbar.vala"
	_data19_->_ref_count_ = 1;
#line 124 "../editor/pathbar.vala"
	_data19_->self = g_object_ref (self);
#line 124 "../editor/pathbar.vala"
	_tmp0_ = g_strdup (non_ghost_path);
#line 124 "../editor/pathbar.vala"
	_g_free0 (_data19_->non_ghost_path);
#line 124 "../editor/pathbar.vala"
	_data19_->non_ghost_path = _tmp0_;
#line 124 "../editor/pathbar.vala"
	_data19_->is_search = is_search;
#line 126 "../editor/pathbar.vala"
	_tmp1_ = g_strdup ("");
#line 126 "../editor/pathbar.vala"
	_data19_->action_target = _tmp1_;
#line 127 "../editor/pathbar.vala"
	gtk_container_foreach ((GtkContainer*) self, ___lambda33__gtk_callback, _data19_);
#line 124 "../editor/pathbar.vala"
	block19_data_unref (_data19_);
#line 124 "../editor/pathbar.vala"
	_data19_ = NULL;
#line 1376 "pathbar.c"
}


static Block20Data*
block20_data_ref (Block20Data* _data20_)
{
#line 180 "../editor/pathbar.vala"
	g_atomic_int_inc (&_data20_->_ref_count_);
#line 180 "../editor/pathbar.vala"
	return _data20_;
#line 1387 "pathbar.c"
}


static void
block20_data_unref (void * _userdata_)
{
	Block20Data* _data20_;
	_data20_ = (Block20Data*) _userdata_;
#line 180 "../editor/pathbar.vala"
	if (g_atomic_int_dec_and_test (&_data20_->_ref_count_)) {
#line 1398 "pathbar.c"
		PathBar* self;
#line 180 "../editor/pathbar.vala"
		self = _data20_->self;
#line 180 "../editor/pathbar.vala"
		_g_object_unref0 (self);
#line 180 "../editor/pathbar.vala"
		g_slice_free (Block20Data, _data20_);
#line 1406 "pathbar.c"
	}
}


static void
__lambda31_ (Block20Data* _data20_,
             GtkWidget* child)
{
	PathBar* self;
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	PathBarItem* item = NULL;
	PathBarItem* _tmp3_;
#line 187 "../editor/pathbar.vala"
	self = _data20_->self;
#line 187 "../editor/pathbar.vala"
	g_return_if_fail (child != NULL);
#line 188 "../editor/pathbar.vala"
	if (!G_TYPE_CHECK_INSTANCE_TYPE (child, TYPE_PATH_BAR_ITEM)) {
#line 189 "../editor/pathbar.vala"
		return;
#line 1430 "pathbar.c"
	}
#line 190 "../editor/pathbar.vala"
	_tmp0_ = gtk_widget_get_style_context (child);
#line 190 "../editor/pathbar.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 190 "../editor/pathbar.vala"
	context = _tmp1_;
#line 191 "../editor/pathbar.vala"
	_tmp2_ = context;
#line 191 "../editor/pathbar.vala"
	if (!gtk_style_context_has_class (_tmp2_, "active")) {
#line 192 "../editor/pathbar.vala"
		_g_object_unref0 (context);
#line 192 "../editor/pathbar.vala"
		return;
#line 1446 "pathbar.c"
	}
#line 193 "../editor/pathbar.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (child, TYPE_PATH_BAR_ITEM, PathBarItem));
#line 193 "../editor/pathbar.vala"
	item = _tmp3_;
#line 194 "../editor/pathbar.vala"
	if (_data20_->is_search) {
#line 1454 "pathbar.c"
		PathBarItem* _tmp4_;
		PathBarItem* _tmp5_;
		PathBarItem* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
#line 196 "../editor/pathbar.vala"
		_tmp4_ = item;
#line 196 "../editor/pathbar.vala"
		path_bar_item_set_cursor_type (_tmp4_, PATH_BAR_ITEM_CURSOR_TYPE_POINTER);
#line 197 "../editor/pathbar.vala"
		_tmp5_ = item;
#line 197 "../editor/pathbar.vala"
		_tmp6_ = item;
#line 197 "../editor/pathbar.vala"
		_tmp7_ = path_bar_item_get_default_action (_tmp6_);
#line 197 "../editor/pathbar.vala"
		_tmp8_ = _tmp7_;
#line 197 "../editor/pathbar.vala"
		gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp5_, _tmp8_);
#line 1474 "pathbar.c"
	} else {
		PathBarItem* _tmp9_;
		PathBarItem* _tmp10_;
#line 201 "../editor/pathbar.vala"
		_tmp9_ = item;
#line 201 "../editor/pathbar.vala"
		path_bar_item_set_cursor_type (_tmp9_, PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT);
#line 202 "../editor/pathbar.vala"
		_tmp10_ = item;
#line 202 "../editor/pathbar.vala"
		gtk_actionable_set_action_name ((GtkActionable*) _tmp10_, "ui.empty");
#line 1486 "pathbar.c"
	}
#line 187 "../editor/pathbar.vala"
	_g_object_unref0 (item);
#line 187 "../editor/pathbar.vala"
	_g_object_unref0 (context);
#line 1492 "pathbar.c"
}


static void
___lambda31__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
#line 187 "../editor/pathbar.vala"
	__lambda31_ (self, widget);
#line 1502 "pathbar.c"
}


static void
path_bar_update_cursors_for_search (PathBar* self,
                                    const gchar* current_path,
                                    gboolean is_search)
{
	Block20Data* _data20_;
#line 180 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 180 "../editor/pathbar.vala"
	g_return_if_fail (current_path != NULL);
#line 180 "../editor/pathbar.vala"
	_data20_ = g_slice_new0 (Block20Data);
#line 180 "../editor/pathbar.vala"
	_data20_->_ref_count_ = 1;
#line 180 "../editor/pathbar.vala"
	_data20_->self = g_object_ref (self);
#line 180 "../editor/pathbar.vala"
	_data20_->is_search = is_search;
#line 182 "../editor/pathbar.vala"
	if (_data20_->is_search) {
#line 1526 "pathbar.c"
		GtkStyleContext* _tmp0_;
#line 183 "../editor/pathbar.vala"
		_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 183 "../editor/pathbar.vala"
		gtk_style_context_add_class (_tmp0_, "greyed-pathbar");
#line 1532 "pathbar.c"
	} else {
		GtkStyleContext* _tmp1_;
#line 185 "../editor/pathbar.vala"
		_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 185 "../editor/pathbar.vala"
		gtk_style_context_remove_class (_tmp1_, "greyed-pathbar");
#line 1539 "pathbar.c"
	}
#line 187 "../editor/pathbar.vala"
	gtk_container_foreach ((GtkContainer*) self, ___lambda31__gtk_callback, _data20_);
#line 180 "../editor/pathbar.vala"
	block20_data_unref (_data20_);
#line 180 "../editor/pathbar.vala"
	_data20_ = NULL;
#line 1547 "pathbar.c"
}


static void
path_bar_add_slash_label (PathBar* self)
{
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
#line 211 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 213 "../editor/pathbar.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new ("/");
#line 213 "../editor/pathbar.vala"
	g_object_ref_sink (_tmp0_);
#line 213 "../editor/pathbar.vala"
	_tmp1_ = _tmp0_;
#line 213 "../editor/pathbar.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp1_);
#line 213 "../editor/pathbar.vala"
	_g_object_unref0 (_tmp1_);
#line 1568 "pathbar.c"
}


static void
path_bar_add_path_bar_item (PathBar* self,
                            const gchar* label,
                            const gchar* complete_path,
                            gboolean is_folder,
                            gboolean block)
{
	PathBarItem* path_bar_item = NULL;
	PathBarItem* _tmp28_;
	PathBarItem* _tmp29_;
#line 216 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 216 "../editor/pathbar.vala"
	g_return_if_fail (label != NULL);
#line 216 "../editor/pathbar.vala"
	g_return_if_fail (complete_path != NULL);
#line 219 "../editor/pathbar.vala"
	if (is_folder) {
#line 1590 "pathbar.c"
		GVariant* variant = NULL;
		GVariant* _tmp0_;
		gchar* _variant = NULL;
		GVariant* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		PathBarItem* _tmp13_;
#line 221 "../editor/pathbar.vala"
		_tmp0_ = g_variant_new_string (complete_path);
#line 221 "../editor/pathbar.vala"
		g_variant_ref_sink (_tmp0_);
#line 221 "../editor/pathbar.vala"
		variant = _tmp0_;
#line 222 "../editor/pathbar.vala"
		_tmp1_ = variant;
#line 222 "../editor/pathbar.vala"
		_tmp2_ = g_variant_print (_tmp1_, FALSE);
#line 222 "../editor/pathbar.vala"
		_variant = _tmp2_;
#line 223 "../editor/pathbar.vala"
		_tmp3_ = _variant;
#line 223 "../editor/pathbar.vala"
		_tmp4_ = g_strconcat ("ui.open-folder(", _tmp3_, NULL);
#line 223 "../editor/pathbar.vala"
		_tmp5_ = _tmp4_;
#line 223 "../editor/pathbar.vala"
		_tmp6_ = g_strconcat (_tmp5_, ")", NULL);
#line 223 "../editor/pathbar.vala"
		_tmp7_ = _tmp6_;
#line 223 "../editor/pathbar.vala"
		_tmp8_ = _variant;
#line 223 "../editor/pathbar.vala"
		_tmp9_ = g_strconcat ("ui.notify-folder-emptied(", _tmp8_, NULL);
#line 223 "../editor/pathbar.vala"
		_tmp10_ = _tmp9_;
#line 223 "../editor/pathbar.vala"
		_tmp11_ = g_strconcat (_tmp10_, ")", NULL);
#line 223 "../editor/pathbar.vala"
		_tmp12_ = _tmp11_;
#line 223 "../editor/pathbar.vala"
		_tmp13_ = path_bar_item_new (label, _tmp7_, _tmp12_);
#line 223 "../editor/pathbar.vala"
		g_object_ref_sink (_tmp13_);
#line 223 "../editor/pathbar.vala"
		_g_object_unref0 (path_bar_item);
#line 223 "../editor/pathbar.vala"
		path_bar_item = _tmp13_;
#line 223 "../editor/pathbar.vala"
		_g_free0 (_tmp12_);
#line 223 "../editor/pathbar.vala"
		_g_free0 (_tmp10_);
#line 223 "../editor/pathbar.vala"
		_g_free0 (_tmp7_);
#line 223 "../editor/pathbar.vala"
		_g_free0 (_tmp5_);
#line 219 "../editor/pathbar.vala"
		_g_free0 (_variant);
#line 219 "../editor/pathbar.vala"
		_g_variant_unref0 (variant);
#line 1659 "pathbar.c"
	} else {
		GVariant* variant = NULL;
		GVariant* _tmp14_;
		gchar* _variant = NULL;
		GVariant* _tmp15_;
		gchar* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		PathBarItem* _tmp27_;
#line 227 "../editor/pathbar.vala"
		_tmp14_ = g_variant_new ("(sq)", complete_path, MODEL_UTILS_undefined_context_id, NULL);
#line 227 "../editor/pathbar.vala"
		g_variant_ref_sink (_tmp14_);
#line 227 "../editor/pathbar.vala"
		variant = _tmp14_;
#line 228 "../editor/pathbar.vala"
		_tmp15_ = variant;
#line 228 "../editor/pathbar.vala"
		_tmp16_ = g_variant_print (_tmp15_, TRUE);
#line 228 "../editor/pathbar.vala"
		_variant = _tmp16_;
#line 229 "../editor/pathbar.vala"
		_tmp17_ = _variant;
#line 229 "../editor/pathbar.vala"
		_tmp18_ = g_strconcat ("ui.open-object(", _tmp17_, NULL);
#line 229 "../editor/pathbar.vala"
		_tmp19_ = _tmp18_;
#line 229 "../editor/pathbar.vala"
		_tmp20_ = g_strconcat (_tmp19_, ")", NULL);
#line 229 "../editor/pathbar.vala"
		_tmp21_ = _tmp20_;
#line 229 "../editor/pathbar.vala"
		_tmp22_ = _variant;
#line 229 "../editor/pathbar.vala"
		_tmp23_ = g_strconcat ("ui.notify-object-deleted(", _tmp22_, NULL);
#line 229 "../editor/pathbar.vala"
		_tmp24_ = _tmp23_;
#line 229 "../editor/pathbar.vala"
		_tmp25_ = g_strconcat (_tmp24_, ")", NULL);
#line 229 "../editor/pathbar.vala"
		_tmp26_ = _tmp25_;
#line 229 "../editor/pathbar.vala"
		_tmp27_ = path_bar_item_new (label, _tmp21_, _tmp26_);
#line 229 "../editor/pathbar.vala"
		g_object_ref_sink (_tmp27_);
#line 229 "../editor/pathbar.vala"
		_g_object_unref0 (path_bar_item);
#line 229 "../editor/pathbar.vala"
		path_bar_item = _tmp27_;
#line 229 "../editor/pathbar.vala"
		_g_free0 (_tmp26_);
#line 229 "../editor/pathbar.vala"
		_g_free0 (_tmp24_);
#line 229 "../editor/pathbar.vala"
		_g_free0 (_tmp21_);
#line 229 "../editor/pathbar.vala"
		_g_free0 (_tmp19_);
#line 219 "../editor/pathbar.vala"
		_g_free0 (_variant);
#line 219 "../editor/pathbar.vala"
		_g_variant_unref0 (variant);
#line 1729 "pathbar.c"
	}
#line 231 "../editor/pathbar.vala"
	_tmp28_ = path_bar_item;
#line 231 "../editor/pathbar.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp28_);
#line 232 "../editor/pathbar.vala"
	_tmp29_ = path_bar_item;
#line 232 "../editor/pathbar.vala"
	path_bar_activate_item (self, _tmp29_, block);
#line 216 "../editor/pathbar.vala"
	_g_object_unref0 (path_bar_item);
#line 1741 "pathbar.c"
}


static void
path_bar_activate_item (PathBar* self,
                        PathBarItem* item,
                        gboolean state)
{
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
#line 235 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 235 "../editor/pathbar.vala"
	g_return_if_fail (item != NULL);
#line 237 "../editor/pathbar.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) item);
#line 237 "../editor/pathbar.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 237 "../editor/pathbar.vala"
	context = _tmp1_;
#line 238 "../editor/pathbar.vala"
	_tmp2_ = context;
#line 238 "../editor/pathbar.vala"
	if (state == gtk_style_context_has_class (_tmp2_, "active")) {
#line 239 "../editor/pathbar.vala"
		_g_object_unref0 (context);
#line 239 "../editor/pathbar.vala"
		return;
#line 1772 "pathbar.c"
	}
#line 240 "../editor/pathbar.vala"
	if (state) {
#line 1776 "pathbar.c"
		GtkStyleContext* _tmp3_;
#line 242 "../editor/pathbar.vala"
		path_bar_item_set_cursor_type (item, PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT);
#line 243 "../editor/pathbar.vala"
		gtk_actionable_set_action_name ((GtkActionable*) item, "ui.empty");
#line 244 "../editor/pathbar.vala"
		_tmp3_ = context;
#line 244 "../editor/pathbar.vala"
		gtk_style_context_add_class (_tmp3_, "active");
#line 1786 "pathbar.c"
	} else {
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		GtkStyleContext* _tmp6_;
#line 248 "../editor/pathbar.vala"
		path_bar_item_set_cursor_type (item, PATH_BAR_ITEM_CURSOR_TYPE_POINTER);
#line 249 "../editor/pathbar.vala"
		_tmp4_ = path_bar_item_get_default_action (item);
#line 249 "../editor/pathbar.vala"
		_tmp5_ = _tmp4_;
#line 249 "../editor/pathbar.vala"
		gtk_actionable_set_detailed_action_name ((GtkActionable*) item, _tmp5_);
#line 250 "../editor/pathbar.vala"
		_tmp6_ = context;
#line 250 "../editor/pathbar.vala"
		gtk_style_context_remove_class (_tmp6_, "active");
#line 1803 "pathbar.c"
	}
#line 235 "../editor/pathbar.vala"
	_g_object_unref0 (context);
#line 1807 "pathbar.c"
}


PathBar*
path_bar_construct (GType object_type)
{
	PathBar * self = NULL;
#line 21 "../editor/pathbar.vala"
	self = (PathBar*) g_object_new (object_type, NULL);
#line 21 "../editor/pathbar.vala"
	return self;
#line 1819 "pathbar.c"
}


PathBar*
path_bar_new (void)
{
#line 21 "../editor/pathbar.vala"
	return path_bar_construct (TYPE_PATH_BAR);
#line 1828 "pathbar.c"
}


const gchar*
path_bar_get_complete_path (PathBar* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 25 "../editor/pathbar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../editor/pathbar.vala"
	_tmp0_ = self->priv->_complete_path;
#line 25 "../editor/pathbar.vala"
	result = _tmp0_;
#line 25 "../editor/pathbar.vala"
	return result;
#line 1845 "pathbar.c"
}


static void
path_bar_set_complete_path (PathBar* self,
                            const gchar* value)
{
#line 25 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 25 "../editor/pathbar.vala"
	if (g_strcmp0 (value, path_bar_get_complete_path (self)) != 0) {
#line 1857 "pathbar.c"
		gchar* _tmp0_;
#line 25 "../editor/pathbar.vala"
		_tmp0_ = g_strdup (value);
#line 25 "../editor/pathbar.vala"
		_g_free0 (self->priv->_complete_path);
#line 25 "../editor/pathbar.vala"
		self->priv->_complete_path = _tmp0_;
#line 25 "../editor/pathbar.vala"
		g_object_notify_by_pspec ((GObject *) self, path_bar_properties[PATH_BAR_COMPLETE_PATH_PROPERTY]);
#line 1867 "pathbar.c"
	}
}


static GObject *
path_bar_constructor (GType type,
                      guint n_construct_properties,
                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PathBar * self;
#line 27 "../editor/pathbar.vala"
	parent_class = G_OBJECT_CLASS (path_bar_parent_class);
#line 27 "../editor/pathbar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 27 "../editor/pathbar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PATH_BAR, PathBar);
#line 29 "../editor/pathbar.vala"
	path_bar_add_slash_label (self);
#line 27 "../editor/pathbar.vala"
	return obj;
#line 1890 "pathbar.c"
}


static void
path_bar_class_init (PathBarClass * klass)
{
#line 21 "../editor/pathbar.vala"
	path_bar_parent_class = g_type_class_peek_parent (klass);
#line 21 "../editor/pathbar.vala"
	g_type_class_adjust_private_offset (klass, &PathBar_private_offset);
#line 21 "../editor/pathbar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_path_bar_get_property;
#line 21 "../editor/pathbar.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_path_bar_set_property;
#line 21 "../editor/pathbar.vala"
	G_OBJECT_CLASS (klass)->constructor = path_bar_constructor;
#line 21 "../editor/pathbar.vala"
	G_OBJECT_CLASS (klass)->finalize = path_bar_finalize;
#line 21 "../editor/pathbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PATH_BAR_COMPLETE_PATH_PROPERTY, path_bar_properties[PATH_BAR_COMPLETE_PATH_PROPERTY] = g_param_spec_string ("complete-path", "complete-path", "complete-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../editor/pathbar.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/ca/desrt/dconf-editor/ui/pathbar.ui");
#line 21 "../editor/pathbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "root_button", FALSE, PathBar_private_offset + G_STRUCT_OFFSET (PathBarPrivate, root_button));
#line 1915 "pathbar.c"
}


static void
path_bar_instance_init (PathBar * self)
{
	gchar* _tmp0_;
#line 21 "../editor/pathbar.vala"
	self->priv = path_bar_get_instance_private (self);
#line 25 "../editor/pathbar.vala"
	_tmp0_ = g_strdup ("");
#line 25 "../editor/pathbar.vala"
	self->priv->_complete_path = _tmp0_;
#line 21 "../editor/pathbar.vala"
	g_type_ensure (TYPE_PATH_BAR_ITEM);
#line 21 "../editor/pathbar.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1933 "pathbar.c"
}


static void
path_bar_finalize (GObject * obj)
{
	PathBar * self;
#line 21 "../editor/pathbar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PATH_BAR, PathBar);
#line 23 "../editor/pathbar.vala"
	_g_object_unref0 (self->priv->root_button);
#line 25 "../editor/pathbar.vala"
	_g_free0 (self->priv->_complete_path);
#line 21 "../editor/pathbar.vala"
	G_OBJECT_CLASS (path_bar_parent_class)->finalize (obj);
#line 1949 "pathbar.c"
}


GType
path_bar_get_type (void)
{
	static volatile gsize path_bar_type_id__volatile = 0;
	if (g_once_init_enter (&path_bar_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PathBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) path_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PathBar), 0, (GInstanceInitFunc) path_bar_instance_init, NULL };
		GType path_bar_type_id;
		path_bar_type_id = g_type_register_static (gtk_box_get_type (), "PathBar", &g_define_type_info, 0);
		PathBar_private_offset = g_type_add_instance_private (path_bar_type_id, sizeof (PathBarPrivate));
		g_once_init_leave (&path_bar_type_id__volatile, path_bar_type_id);
	}
	return path_bar_type_id__volatile;
}


static void
_vala_path_bar_get_property (GObject * object,
                             guint property_id,
                             GValue * value,
                             GParamSpec * pspec)
{
	PathBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PATH_BAR, PathBar);
#line 21 "../editor/pathbar.vala"
	switch (property_id) {
#line 21 "../editor/pathbar.vala"
		case PATH_BAR_COMPLETE_PATH_PROPERTY:
#line 21 "../editor/pathbar.vala"
		g_value_set_string (value, path_bar_get_complete_path (self));
#line 21 "../editor/pathbar.vala"
		break;
#line 1984 "pathbar.c"
		default:
#line 21 "../editor/pathbar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../editor/pathbar.vala"
		break;
#line 1990 "pathbar.c"
	}
}


static void
_vala_path_bar_set_property (GObject * object,
                             guint property_id,
                             const GValue * value,
                             GParamSpec * pspec)
{
	PathBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PATH_BAR, PathBar);
#line 21 "../editor/pathbar.vala"
	switch (property_id) {
#line 21 "../editor/pathbar.vala"
		case PATH_BAR_COMPLETE_PATH_PROPERTY:
#line 21 "../editor/pathbar.vala"
		path_bar_set_complete_path (self, g_value_get_string (value));
#line 21 "../editor/pathbar.vala"
		break;
#line 2011 "pathbar.c"
		default:
#line 21 "../editor/pathbar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../editor/pathbar.vala"
		break;
#line 2017 "pathbar.c"
	}
}


static inline gpointer
path_bar_item_get_instance_private (PathBarItem* self)
{
	return G_STRUCT_MEMBER_P (self, PathBarItem_private_offset);
}


GType
path_bar_item_cursor_type_get_type (void)
{
	static volatile gsize path_bar_item_cursor_type_type_id__volatile = 0;
	if (g_once_init_enter (&path_bar_item_cursor_type_type_id__volatile)) {
		static const GEnumValue values[] = {{PATH_BAR_ITEM_CURSOR_TYPE_DEFAULT, "PATH_BAR_ITEM_CURSOR_TYPE_DEFAULT", "default"}, {PATH_BAR_ITEM_CURSOR_TYPE_POINTER, "PATH_BAR_ITEM_CURSOR_TYPE_POINTER", "pointer"}, {PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT, "PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT", "context"}, {0, NULL, NULL}};
		GType path_bar_item_cursor_type_type_id;
		path_bar_item_cursor_type_type_id = g_enum_register_static ("PathBarItemCursorType", values);
		g_once_init_leave (&path_bar_item_cursor_type_type_id__volatile, path_bar_item_cursor_type_type_id);
	}
	return path_bar_item_cursor_type_type_id__volatile;
}


void
path_bar_item_set_cursor_type (PathBarItem* self,
                               PathBarItemCursorType cursor_type)
{
	gboolean _tmp0_;
#line 278 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 280 "../editor/pathbar.vala"
	self->priv->cursor_type = cursor_type;
#line 281 "../editor/pathbar.vala"
	_tmp0_ = self->priv->hover;
#line 281 "../editor/pathbar.vala"
	if (_tmp0_) {
#line 282 "../editor/pathbar.vala"
		path_bar_item_set_new_cursor_type (self, cursor_type);
#line 2058 "pathbar.c"
	}
}


static void
path_bar_item_set_new_cursor_type (PathBarItem* self,
                                   PathBarItemCursorType new_cursor_type)
{
	GdkWindow* gdk_window = NULL;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp2_;
	GdkDisplay* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GdkWindow* _tmp5_;
	GdkCursor* cursor = NULL;
	GdkWindow* _tmp11_;
	GdkCursor* _tmp12_;
#line 285 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 287 "../editor/pathbar.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 287 "../editor/pathbar.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 287 "../editor/pathbar.vala"
	gdk_window = _tmp1_;
#line 288 "../editor/pathbar.vala"
	_tmp2_ = gdk_display_get_default ();
#line 288 "../editor/pathbar.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 288 "../editor/pathbar.vala"
	display = _tmp3_;
#line 289 "../editor/pathbar.vala"
	_tmp5_ = gdk_window;
#line 289 "../editor/pathbar.vala"
	if (_tmp5_ == NULL) {
#line 289 "../editor/pathbar.vala"
		_tmp4_ = TRUE;
#line 2098 "pathbar.c"
	} else {
		GdkDisplay* _tmp6_;
#line 289 "../editor/pathbar.vala"
		_tmp6_ = display;
#line 289 "../editor/pathbar.vala"
		_tmp4_ = _tmp6_ == NULL;
#line 2105 "pathbar.c"
	}
#line 289 "../editor/pathbar.vala"
	if (_tmp4_) {
#line 290 "../editor/pathbar.vala"
		_g_object_unref0 (display);
#line 290 "../editor/pathbar.vala"
		_g_object_unref0 (gdk_window);
#line 290 "../editor/pathbar.vala"
		return;
#line 2115 "pathbar.c"
	}
#line 292 "../editor/pathbar.vala"
	cursor = NULL;
#line 293 "../editor/pathbar.vala"
	switch (new_cursor_type) {
#line 293 "../editor/pathbar.vala"
		case PATH_BAR_ITEM_CURSOR_TYPE_DEFAULT:
#line 2123 "pathbar.c"
		{
#line 295 "../editor/pathbar.vala"
			_g_object_unref0 (cursor);
#line 295 "../editor/pathbar.vala"
			cursor = NULL;
#line 295 "../editor/pathbar.vala"
			break;
#line 2131 "pathbar.c"
		}
#line 293 "../editor/pathbar.vala"
		case PATH_BAR_ITEM_CURSOR_TYPE_POINTER:
#line 2135 "pathbar.c"
		{
			GdkDisplay* _tmp7_;
			GdkCursor* _tmp8_;
#line 296 "../editor/pathbar.vala"
			_tmp7_ = display;
#line 296 "../editor/pathbar.vala"
			_tmp8_ = gdk_cursor_new_from_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gdk_display_get_type (), GdkDisplay), "pointer");
#line 296 "../editor/pathbar.vala"
			_g_object_unref0 (cursor);
#line 296 "../editor/pathbar.vala"
			cursor = _tmp8_;
#line 296 "../editor/pathbar.vala"
			break;
#line 2149 "pathbar.c"
		}
#line 293 "../editor/pathbar.vala"
		case PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT:
#line 2153 "pathbar.c"
		{
			GdkDisplay* _tmp9_;
			GdkCursor* _tmp10_;
#line 297 "../editor/pathbar.vala"
			_tmp9_ = display;
#line 297 "../editor/pathbar.vala"
			_tmp10_ = gdk_cursor_new_from_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gdk_display_get_type (), GdkDisplay), "context-menu");
#line 297 "../editor/pathbar.vala"
			_g_object_unref0 (cursor);
#line 297 "../editor/pathbar.vala"
			cursor = _tmp10_;
#line 297 "../editor/pathbar.vala"
			break;
#line 2167 "pathbar.c"
		}
		default:
#line 293 "../editor/pathbar.vala"
		break;
#line 2172 "pathbar.c"
	}
#line 299 "../editor/pathbar.vala"
	_tmp11_ = gdk_window;
#line 299 "../editor/pathbar.vala"
	_tmp12_ = cursor;
#line 299 "../editor/pathbar.vala"
	gdk_window_set_cursor (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gdk_window_get_type (), GdkWindow), _tmp12_);
#line 285 "../editor/pathbar.vala"
	_g_object_unref0 (cursor);
#line 285 "../editor/pathbar.vala"
	_g_object_unref0 (display);
#line 285 "../editor/pathbar.vala"
	_g_object_unref0 (gdk_window);
#line 2186 "pathbar.c"
}


static void
path_bar_item_update_cursor (PathBarItem* self)
{
	gboolean _tmp0_ = FALSE;
	GtkStyleContext* _tmp1_;
	PathBarItemCursorType _tmp3_;
	GMenu* menu = NULL;
	GMenu* _tmp5_;
	GMenu* _tmp6_;
	GMenu* _tmp7_;
	GtkPopover* popover_test = NULL;
	GMenu* _tmp8_;
	GtkPopover* _tmp9_;
	GtkPopover* _tmp10_;
#line 303 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 305 "../editor/pathbar.vala"
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 305 "../editor/pathbar.vala"
	if (gtk_style_context_has_class (_tmp1_, "inexistent")) {
#line 2210 "pathbar.c"
		GtkStyleContext* _tmp2_;
#line 305 "../editor/pathbar.vala"
		_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 305 "../editor/pathbar.vala"
		_tmp0_ = !gtk_style_context_has_class (_tmp2_, "active");
#line 2216 "pathbar.c"
	} else {
#line 305 "../editor/pathbar.vala"
		_tmp0_ = FALSE;
#line 2220 "pathbar.c"
	}
#line 305 "../editor/pathbar.vala"
	if (_tmp0_) {
#line 306 "../editor/pathbar.vala"
		return;
#line 2226 "pathbar.c"
	}
#line 308 "../editor/pathbar.vala"
	_tmp3_ = self->priv->cursor_type;
#line 308 "../editor/pathbar.vala"
	if (_tmp3_ != PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT) {
#line 2232 "pathbar.c"
		PathBarItemCursorType _tmp4_;
#line 310 "../editor/pathbar.vala"
		self->priv->cursor_type = PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT;
#line 311 "../editor/pathbar.vala"
		_tmp4_ = self->priv->cursor_type;
#line 311 "../editor/pathbar.vala"
		path_bar_item_set_new_cursor_type (self, _tmp4_);
#line 312 "../editor/pathbar.vala"
		return;
#line 2242 "pathbar.c"
	}
#line 315 "../editor/pathbar.vala"
	_tmp5_ = g_menu_new ();
#line 315 "../editor/pathbar.vala"
	menu = _tmp5_;
#line 316 "../editor/pathbar.vala"
	_tmp6_ = menu;
#line 316 "../editor/pathbar.vala"
	g_menu_append (_tmp6_, _ ("Copy current path"), "ui.copy-path");
#line 317 "../editor/pathbar.vala"
	_tmp7_ = menu;
#line 317 "../editor/pathbar.vala"
	g_menu_freeze (_tmp7_);
#line 319 "../editor/pathbar.vala"
	_tmp8_ = menu;
#line 319 "../editor/pathbar.vala"
	_tmp9_ = (GtkPopover*) gtk_popover_new_from_model ((GtkWidget*) self, G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, g_menu_model_get_type (), GMenuModel));
#line 319 "../editor/pathbar.vala"
	g_object_ref_sink (_tmp9_);
#line 319 "../editor/pathbar.vala"
	popover_test = _tmp9_;
#line 320 "../editor/pathbar.vala"
	_tmp10_ = popover_test;
#line 320 "../editor/pathbar.vala"
	gtk_popover_popup (_tmp10_);
#line 303 "../editor/pathbar.vala"
	_g_object_unref0 (popover_test);
#line 303 "../editor/pathbar.vala"
	_g_object_unref0 (menu);
#line 2272 "pathbar.c"
}


static void
_path_bar_item_update_cursor_gtk_button_clicked (GtkButton* _sender,
                                                 gpointer self)
{
#line 256 "../editor/pathbar.vala"
	path_bar_item_update_cursor ((PathBarItem*) self);
#line 2282 "pathbar.c"
}


PathBarItem*
path_bar_item_construct (GType object_type,
                         const gchar* label,
                         const gchar* _default_action,
                         const gchar* _alternative_action)
{
	PathBarItem * self = NULL;
	GtkLabel* _tmp0_;
#line 323 "../editor/pathbar.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 323 "../editor/pathbar.vala"
	g_return_val_if_fail (_default_action != NULL, NULL);
#line 323 "../editor/pathbar.vala"
	g_return_val_if_fail (_alternative_action != NULL, NULL);
#line 325 "../editor/pathbar.vala"
	self = (PathBarItem*) g_object_new (object_type, "text-string", label, "default-action", _default_action, "alternative-action", _alternative_action, NULL);
#line 326 "../editor/pathbar.vala"
	_tmp0_ = self->priv->text_label;
#line 326 "../editor/pathbar.vala"
	gtk_label_set_text (_tmp0_, label);
#line 327 "../editor/pathbar.vala"
	gtk_actionable_set_detailed_action_name ((GtkActionable*) self, _default_action);
#line 323 "../editor/pathbar.vala"
	return self;
#line 2310 "pathbar.c"
}


PathBarItem*
path_bar_item_new (const gchar* label,
                   const gchar* _default_action,
                   const gchar* _alternative_action)
{
#line 323 "../editor/pathbar.vala"
	return path_bar_item_construct (TYPE_PATH_BAR_ITEM, label, _default_action, _alternative_action);
#line 2321 "pathbar.c"
}


const gchar*
path_bar_item_get_alternative_action (PathBarItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 258 "../editor/pathbar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 258 "../editor/pathbar.vala"
	_tmp0_ = self->priv->_alternative_action;
#line 258 "../editor/pathbar.vala"
	result = _tmp0_;
#line 258 "../editor/pathbar.vala"
	return result;
#line 2338 "pathbar.c"
}


static void
path_bar_item_set_alternative_action (PathBarItem* self,
                                      const gchar* value)
{
#line 258 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 258 "../editor/pathbar.vala"
	if (g_strcmp0 (value, path_bar_item_get_alternative_action (self)) != 0) {
#line 2350 "pathbar.c"
		gchar* _tmp0_;
#line 258 "../editor/pathbar.vala"
		_tmp0_ = g_strdup (value);
#line 258 "../editor/pathbar.vala"
		_g_free0 (self->priv->_alternative_action);
#line 258 "../editor/pathbar.vala"
		self->priv->_alternative_action = _tmp0_;
#line 258 "../editor/pathbar.vala"
		g_object_notify_by_pspec ((GObject *) self, path_bar_item_properties[PATH_BAR_ITEM_ALTERNATIVE_ACTION_PROPERTY]);
#line 2360 "pathbar.c"
	}
}


const gchar*
path_bar_item_get_default_action (PathBarItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 259 "../editor/pathbar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 259 "../editor/pathbar.vala"
	_tmp0_ = self->priv->_default_action;
#line 259 "../editor/pathbar.vala"
	result = _tmp0_;
#line 259 "../editor/pathbar.vala"
	return result;
#line 2378 "pathbar.c"
}


static void
path_bar_item_set_default_action (PathBarItem* self,
                                  const gchar* value)
{
#line 259 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 259 "../editor/pathbar.vala"
	if (g_strcmp0 (value, path_bar_item_get_default_action (self)) != 0) {
#line 2390 "pathbar.c"
		gchar* _tmp0_;
#line 259 "../editor/pathbar.vala"
		_tmp0_ = g_strdup (value);
#line 259 "../editor/pathbar.vala"
		_g_free0 (self->priv->_default_action);
#line 259 "../editor/pathbar.vala"
		self->priv->_default_action = _tmp0_;
#line 259 "../editor/pathbar.vala"
		g_object_notify_by_pspec ((GObject *) self, path_bar_item_properties[PATH_BAR_ITEM_DEFAULT_ACTION_PROPERTY]);
#line 2400 "pathbar.c"
	}
}


const gchar*
path_bar_item_get_text_string (PathBarItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 260 "../editor/pathbar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 260 "../editor/pathbar.vala"
	_tmp0_ = self->priv->_text_string;
#line 260 "../editor/pathbar.vala"
	result = _tmp0_;
#line 260 "../editor/pathbar.vala"
	return result;
#line 2418 "pathbar.c"
}


static void
path_bar_item_set_text_string (PathBarItem* self,
                               const gchar* value)
{
#line 260 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 260 "../editor/pathbar.vala"
	if (g_strcmp0 (value, path_bar_item_get_text_string (self)) != 0) {
#line 2430 "pathbar.c"
		gchar* _tmp0_;
#line 260 "../editor/pathbar.vala"
		_tmp0_ = g_strdup (value);
#line 260 "../editor/pathbar.vala"
		_g_free0 (self->priv->_text_string);
#line 260 "../editor/pathbar.vala"
		self->priv->_text_string = _tmp0_;
#line 260 "../editor/pathbar.vala"
		g_object_notify_by_pspec ((GObject *) self, path_bar_item_properties[PATH_BAR_ITEM_TEXT_STRING_PROPERTY]);
#line 2440 "pathbar.c"
	}
}


static gboolean
_path_bar_item___lambda29_ (PathBarItem* self)
{
	gboolean result = FALSE;
	PathBarItemCursorType _tmp0_;
#line 274 "../editor/pathbar.vala"
	self->priv->hover = TRUE;
#line 274 "../editor/pathbar.vala"
	_tmp0_ = self->priv->cursor_type;
#line 274 "../editor/pathbar.vala"
	path_bar_item_set_new_cursor_type (self, _tmp0_);
#line 2456 "pathbar.c"
}


static gboolean
__path_bar_item___lambda29__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                           GdkEventCrossing* event,
                                                           gpointer self)
{
	gboolean result;
	result = _path_bar_item___lambda29_ ((PathBarItem*) self);
#line 274 "../editor/pathbar.vala"
	return result;
#line 2469 "pathbar.c"
}


static gboolean
_path_bar_item___lambda30_ (PathBarItem* self)
{
	gboolean result = FALSE;
#line 275 "../editor/pathbar.vala"
	self->priv->hover = FALSE;
#line 275 "../editor/pathbar.vala"
	path_bar_item_set_new_cursor_type (self, PATH_BAR_ITEM_CURSOR_TYPE_DEFAULT);
#line 2481 "pathbar.c"
}


static gboolean
__path_bar_item___lambda30__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                           GdkEventCrossing* event,
                                                           gpointer self)
{
	gboolean result;
	result = _path_bar_item___lambda30_ ((PathBarItem*) self);
#line 275 "../editor/pathbar.vala"
	return result;
#line 2494 "pathbar.c"
}


static GObject *
path_bar_item_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PathBarItem * self;
#line 272 "../editor/pathbar.vala"
	parent_class = G_OBJECT_CLASS (path_bar_item_parent_class);
#line 272 "../editor/pathbar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 272 "../editor/pathbar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PATH_BAR_ITEM, PathBarItem);
#line 274 "../editor/pathbar.vala"
	g_signal_connect_object ((GtkWidget*) self, "enter-notify-event", (GCallback) __path_bar_item___lambda29__gtk_widget_enter_notify_event, self, 0);
#line 275 "../editor/pathbar.vala"
	g_signal_connect_object ((GtkWidget*) self, "leave-notify-event", (GCallback) __path_bar_item___lambda30__gtk_widget_leave_notify_event, self, 0);
#line 272 "../editor/pathbar.vala"
	return obj;
#line 2518 "pathbar.c"
}


static void
path_bar_item_class_init (PathBarItemClass * klass)
{
#line 256 "../editor/pathbar.vala"
	path_bar_item_parent_class = g_type_class_peek_parent (klass);
#line 256 "../editor/pathbar.vala"
	g_type_class_adjust_private_offset (klass, &PathBarItem_private_offset);
#line 256 "../editor/pathbar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_path_bar_item_get_property;
#line 256 "../editor/pathbar.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_path_bar_item_set_property;
#line 256 "../editor/pathbar.vala"
	G_OBJECT_CLASS (klass)->constructor = path_bar_item_constructor;
#line 256 "../editor/pathbar.vala"
	G_OBJECT_CLASS (klass)->finalize = path_bar_item_finalize;
#line 256 "../editor/pathbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PATH_BAR_ITEM_ALTERNATIVE_ACTION_PROPERTY, path_bar_item_properties[PATH_BAR_ITEM_ALTERNATIVE_ACTION_PROPERTY] = g_param_spec_string ("alternative-action", "alternative-action", "alternative-action", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 256 "../editor/pathbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PATH_BAR_ITEM_DEFAULT_ACTION_PROPERTY, path_bar_item_properties[PATH_BAR_ITEM_DEFAULT_ACTION_PROPERTY] = g_param_spec_string ("default-action", "default-action", "default-action", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 256 "../editor/pathbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PATH_BAR_ITEM_TEXT_STRING_PROPERTY, path_bar_item_properties[PATH_BAR_ITEM_TEXT_STRING_PROPERTY] = g_param_spec_string ("text-string", "text-string", "text-string", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 256 "../editor/pathbar.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/ca/desrt/dconf-editor/ui/pathbar-item.ui");
#line 256 "../editor/pathbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "text_label", FALSE, PathBarItem_private_offset + G_STRUCT_OFFSET (PathBarItemPrivate, text_label));
#line 256 "../editor/pathbar.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "update_cursor", G_CALLBACK(_path_bar_item_update_cursor_gtk_button_clicked));
#line 2549 "pathbar.c"
}


static void
path_bar_item_instance_init (PathBarItem * self)
{
#line 256 "../editor/pathbar.vala"
	self->priv = path_bar_item_get_instance_private (self);
#line 268 "../editor/pathbar.vala"
	self->priv->cursor_type = PATH_BAR_ITEM_CURSOR_TYPE_POINTER;
#line 270 "../editor/pathbar.vala"
	self->priv->hover = FALSE;
#line 256 "../editor/pathbar.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2564 "pathbar.c"
}


static void
path_bar_item_finalize (GObject * obj)
{
	PathBarItem * self;
#line 256 "../editor/pathbar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PATH_BAR_ITEM, PathBarItem);
#line 258 "../editor/pathbar.vala"
	_g_free0 (self->priv->_alternative_action);
#line 259 "../editor/pathbar.vala"
	_g_free0 (self->priv->_default_action);
#line 260 "../editor/pathbar.vala"
	_g_free0 (self->priv->_text_string);
#line 261 "../editor/pathbar.vala"
	_g_object_unref0 (self->priv->text_label);
#line 256 "../editor/pathbar.vala"
	G_OBJECT_CLASS (path_bar_item_parent_class)->finalize (obj);
#line 2584 "pathbar.c"
}


GType
path_bar_item_get_type (void)
{
	static volatile gsize path_bar_item_type_id__volatile = 0;
	if (g_once_init_enter (&path_bar_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PathBarItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) path_bar_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PathBarItem), 0, (GInstanceInitFunc) path_bar_item_instance_init, NULL };
		GType path_bar_item_type_id;
		path_bar_item_type_id = g_type_register_static (gtk_button_get_type (), "PathBarItem", &g_define_type_info, 0);
		PathBarItem_private_offset = g_type_add_instance_private (path_bar_item_type_id, sizeof (PathBarItemPrivate));
		g_once_init_leave (&path_bar_item_type_id__volatile, path_bar_item_type_id);
	}
	return path_bar_item_type_id__volatile;
}


static void
_vala_path_bar_item_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	PathBarItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PATH_BAR_ITEM, PathBarItem);
#line 256 "../editor/pathbar.vala"
	switch (property_id) {
#line 256 "../editor/pathbar.vala"
		case PATH_BAR_ITEM_ALTERNATIVE_ACTION_PROPERTY:
#line 256 "../editor/pathbar.vala"
		g_value_set_string (value, path_bar_item_get_alternative_action (self));
#line 256 "../editor/pathbar.vala"
		break;
#line 256 "../editor/pathbar.vala"
		case PATH_BAR_ITEM_DEFAULT_ACTION_PROPERTY:
#line 256 "../editor/pathbar.vala"
		g_value_set_string (value, path_bar_item_get_default_action (self));
#line 256 "../editor/pathbar.vala"
		break;
#line 256 "../editor/pathbar.vala"
		case PATH_BAR_ITEM_TEXT_STRING_PROPERTY:
#line 256 "../editor/pathbar.vala"
		g_value_set_string (value, path_bar_item_get_text_string (self));
#line 256 "../editor/pathbar.vala"
		break;
#line 2631 "pathbar.c"
		default:
#line 256 "../editor/pathbar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 256 "../editor/pathbar.vala"
		break;
#line 2637 "pathbar.c"
	}
}


static void
_vala_path_bar_item_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	PathBarItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PATH_BAR_ITEM, PathBarItem);
#line 256 "../editor/pathbar.vala"
	switch (property_id) {
#line 256 "../editor/pathbar.vala"
		case PATH_BAR_ITEM_ALTERNATIVE_ACTION_PROPERTY:
#line 256 "../editor/pathbar.vala"
		path_bar_item_set_alternative_action (self, g_value_get_string (value));
#line 256 "../editor/pathbar.vala"
		break;
#line 256 "../editor/pathbar.vala"
		case PATH_BAR_ITEM_DEFAULT_ACTION_PROPERTY:
#line 256 "../editor/pathbar.vala"
		path_bar_item_set_default_action (self, g_value_get_string (value));
#line 256 "../editor/pathbar.vala"
		break;
#line 256 "../editor/pathbar.vala"
		case PATH_BAR_ITEM_TEXT_STRING_PROPERTY:
#line 256 "../editor/pathbar.vala"
		path_bar_item_set_text_string (self, g_value_get_string (value));
#line 256 "../editor/pathbar.vala"
		break;
#line 2670 "pathbar.c"
		default:
#line 256 "../editor/pathbar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 256 "../editor/pathbar.vala"
		break;
#line 2676 "pathbar.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



